#!/bin/bash
#SBATCH 

nmax=1

echo -e "\e[00;31m | Read parameters... \e[00m `date`"
ijob=$1
joblist=$2
pdir=$3
indir=$4
outdir=$5
whichoutput=$6
experiment=$7
criteria=$8
allstation=$9
what="${10}"
echo "inputs         : $ijob/$joblist/$pdir/$indir/$outdir/$whichoutput/$experiment/$criteria/$allstation/$what" 


echo -e "\e[00;31m | Launch the jobs for each MOS model... \e[00m `date`"
subwhat=`   awk -v job=$ijob '{if(NR==job){print $7}}' $joblist` 
nsubwhat=`echo  $subwhat | awk -F'|' '{print NF}'`
echo $subwhat $nsubwhat
for i in `seq 1 $nsubwhat` ; do	
    iwhat=`echo $subwhat | awk -F'|' -v i=$i 'BEGIN{OFS=IFS="\t"}{print $i}'`
    echo "launch model $i/$nsubwhat) $iwhat       `date`"
    $pdir/job_opmos.sh $ijob $joblist $pdir $indir $outdir $whichoutput $experiment $criteria $allstation $iwhat &> $outdir/other/slurm_opmos/subslurm_job${ijob}_${iwhat} 
done


echo -e "\e[00;31m | Wait the end... \e[00m `date`"
ndone=0
while [ $ndone -lt $nwhat ] ; do
    ndone=`  grep END_job_$ijob $outdir/other/slurm_opmos/subslurm_job${ijob}_* | wc -l`
    nerr=`   grep Err           $outdir/other/slurm_opmos/subslurm_job${ijob}_* 2> /dev/null | wc -l`
    nkilled=`grep Killed        $outdir/other/slurm_opmos/subslurm_job${ijob}_* 2> /dev/null | wc -l`
    ncancel=`grep CANCEL        $outdir/other/slurm_opmos/subslurm_job${ijob}_* 2> /dev/null | wc -l`
    sleep 10
    echo "waiting... ($ndone/$nwhat) (NERRORS/NKILLED/NCANCEL=$nerr/$nkilled/$ncancel) `date`"
done


### save the slurm files
#mv $pdir/slurm* $outdir/other/slurm_post/
echo "_THEEND_ `date`" #(do not modify because top_opmos.sh is counting the THEEND occurences...)
