#!/bin/bash


function convertsec(){     # (function for converting time in seconds, used for chrono routines)
    echo $(($1 / 86400))':'`date +%H:%M:%S -d "0000-01-01 $(($1 % 86400)) seconds"`
}
begin=`date +%s` #(start chrono)

echo "****** Read parameters"
ijob=$1
joblist=$2
pdir=$3
indir=$4
outdir=$5
whichoutput=$6
experiment=$7
criteria=$8
allstation=$9
iwhat=${10}
ipollutant=`awk -v job=$ijob '{if(NR==job){print $2}}' $joblist` 
istation=`  awk -v job=$ijob '{if(NR==job){print $3}}' $joblist` 
d1=`        awk -v job=$ijob '{if(NR==job){print $4}}' $joblist` 
d2=`        awk -v job=$ijob '{if(NR==job){print $5}}' $joblist` 
domain=`    awk -v job=$ijob '{if(NR==job){print $6}}' $joblist` 
echo "inputs         : $ijob|$joblist|$pdir|$indir|$outdir|$whichoutput|$experiment|$criteria|$allstation|$iwhat" 
echo "inputs joblist : $ipollutant|istation|$d1|$d2|$domain"





echo "****** Create suboutput (for output files) and workdir (for temporary files) directory"
suboutdir=$outdir/data_${d1}_${d2}_$istation 
workdir=$outdir/tmp/tmp_${ijob}_${d1}_${d2}_${istation}_${iwhat} 
if [ ! -d $suboutdir ] ; then mkdir -p $suboutdir ; fi
if [ ! -d $workdir   ] ; then mkdir -p $workdir   ; fi



echo "****** Launch the R routines"
Rscript routine0_prepare.R $iwhat $indir $workdir $whichoutput $istation $ipollutant $d1 $d2 $experiment $criteria $pdir $domain $allstation


echo "****** Check if results are here - pdf"
ls $workdir/*pdf              2> /dev/null
echo "****** Check if results are here - stat.csv"
ls $workdir/*stat.csv         2> /dev/null
echo "****** Check if results are here - data.csv"
ls $workdir/*data.csv         2> /dev/null
echo "****** Check if results are here - Rdata"
ls $workdir/*Rdata            2> /dev/null
echo "****** Check if results are here - importance.csv"
ls $workdir/*importance.csv   2> /dev/null


echo "****** Move results"
if [ `echo $whichoutput | grep -w pdf        | wc -l` -eq 1 ] ; then mv $workdir/*pdf             $suboutdir 2> /dev/null ; fi
if [ `echo $whichoutput | grep -w stat       | wc -l` -eq 1 ] ; then mv $workdir/*stat.csv        $suboutdir 2> /dev/null ; fi
if [ `echo $whichoutput | grep -w hdata      | wc -l` -eq 1 ] ; then mv $workdir/*hdata.csv       $suboutdir 2> /dev/null ; fi
if [ `echo $whichoutput | grep -w dxdata     | wc -l` -eq 1 ] ; then mv $workdir/*dxdata.csv      $suboutdir 2> /dev/null ; fi
if [ `echo $whichoutput | grep -w mxdata     | wc -l` -eq 1 ] ; then mv $workdir/*mxdata.csv      $suboutdir 2> /dev/null ; fi
if [ `echo $whichoutput | grep -w h24xdata   | wc -l` -eq 1 ] ; then mv $workdir/*h24xdata.csv    $suboutdir 2> /dev/null ; fi
if [ `echo $whichoutput | grep -w dmaxxdata  | wc -l` -eq 1 ] ; then mv $workdir/*dmaxxdata.csv   $suboutdir 2> /dev/null ; fi
if [ `echo $whichoutput | grep -w dmda8xdata | wc -l` -eq 1 ] ; then mv $workdir/*dmda8xdata.csv  $suboutdir 2> /dev/null ; fi
mv $workdir/*Rdata           $suboutdir 2> /dev/null
mv $workdir/*importance.csv  $suboutdir 2> /dev/null

rm -rf $workdir


#(Here stops the chrono)
end=`date +%s`
timejob=`convertsec $(($end-$begin))`  #(copy the convertsec function in my ~/.bashrc to yours)
echo "  END_job_$ijob >>> duration : ${timejob}"



