#!/bin/bash 
#SBATCH --time=01:00:00

post=$1
pdir=$2
outdir=$3
ipollutant=$4
iwhat="$5"
d1=$6
d2=$7
itype=$8

echo "post=$post"
echo "pdir=$pdir"
echo "outdir=$outdir"
echo "ipollutant=$ipollutant"
echo "iwhat=$iwhat"
echo "d1=$d1"
echo "d2=$d2"
echo "itype=$itype"

case $BSC_MACHINE in 
    'power') workdir=$TMPDIR ;;	
    'mn4')
	case $post in 
	    "aggregate1a")     workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat} ;;
	    "aggregate1b")     workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat} ;;
	    "aggregate2a")     workdir=$outdir/tmp/tmppost_${post}_${ipollutant} ;;
	    "aggregate2b")     workdir=$outdir/tmp/tmppost_${post}_${ipollutant} ;;
	    "xxstat")          workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat} ;;
	    "confusion")       workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat}_${itype} ;;
	    "hfopstat")        workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat} ;;
	    "hx1errorbinstat") workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat} ;;
	    "hx1obsbinstat")   workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat} ;;
	    "hopstat")         workdir=$outdir/tmp/tmppost_${post}_${ipollutant}_${iwhat} ;;
	esac
	
	if [ ! -d $workdir ] ; then mkdir -p $workdir ; fi 
	;;
esac

echo "========== post:$post ==========" 


#############################################################################################
if [ "$post" == "aggregate1a" ] ; then
    echo " Aggregate hopdata.Rdata files... "
    ls $outdir/data*/*${ipollutant}_${iwhat}_hopdata.Rdata > $workdir/listrdata_${ipollutant}_${iwhat} 2>/dev/null
    nlines=`wc -l $workdir/listrdata_${ipollutant}_${iwhat} | awk '{print $1}'`
    echo "$workdir/listrdata_${ipollutant}_${iwhat} ($nlines *_hopdata.Rdata files available)"
    if [ $nlines -gt 0 ] ; then
	outfile=$outdir/post_statistics/hopdata_${ipollutant}_${iwhat}
	Rscript $pdir/post.R \
	    $post \
	    $outdir/data_${d1}_${d2}_ \
	    $ipollutant \
	    $iwhat \
	    $outdir/other/tmp_filestations_all \
	    $outfile \
	    $workdir/listrdata_${ipollutant}_${iwhat}      
    fi  
fi
if [ "$post" == "aggregate1b" ] ; then
    echo " Aggregate hdata.Rdata files... "
    ls $outdir/data*/*${ipollutant}_${iwhat}_1_hdata.Rdata > $workdir/listrdata_${ipollutant}_${iwhat} 2>/dev/null
    nlines=`wc -l $workdir/listrdata_${ipollutant}_${iwhat} | awk '{print $1}'`
    echo "$workdir/listrdata_${ipollutant}_${iwhat}_1 ($nlines *_hdata.Rdata files available)"
    if [ $nlines -gt 0 ] ; then
	outfile=$outdir/post_statistics/hdata_${ipollutant}_${iwhat}_1
	Rscript $pdir/post.R \
	    $post \
	    $outdir/data_${d1}_${d2}_ \
	    $ipollutant \
	    $iwhat \
	    $outdir/other/tmp_filestations_all \
	    $outfile \
	    $workdir/listrdata_${ipollutant}_${iwhat}      
    fi  
fi


#############################################################################################
if [ "$post" == "aggregate2a" ] ; then
    echo " Aggregate xhopdata.Rdata files... "
    ls $outdir/post_statistics/hopdata_${ipollutant}_*.Rdata > $workdir/listrdata_${ipollutant} 2>/dev/null
    nlines=`wc -l $workdir/listrdata_${ipollutant} | awk '{print $1}'`
    echo "$workdir/listrdata_${ipollutant} ($nlines *_hopdata.Rdata files available)"
    if [ $nlines -gt 0 ] ; then
	outfile=$outdir/post_statistics/hopdata_${ipollutant}
	Rscript $pdir/post.R \
	    $post \
	    $workdir/listrdata_${ipollutant}  
    fi  
fi
if [ "$post" == "aggregate2b" ] ; then
    echo " Aggregate xhdata.Rdata files... "
    ls $outdir/post_statistics/hdata_${ipollutant}_*_1.Rdata > $workdir/listrdata_${ipollutant} 2>/dev/null
    nlines=`wc -l $workdir/listrdata_${ipollutant} | awk '{print $1}'`
    echo "$workdir/listrdata_${ipollutant} ($nlines *_hdata.Rdata files available)"
    if [ $nlines -gt 0 ] ; then
	outfile=$outdir/post_statistics/hdata_${ipollutant}_1
	Rscript $pdir/post.R \
	    $post \
	    $workdir/listrdata_${ipollutant} \
	    $ipollutant \
	    $iwhat \
	    $outdir/data_${d1}_${d2}_
    fi  
fi



#############################################################################################
if [ "$post" == "xxstat" ] ; then
    echo " Compute xxstat... "
    ls $outdir/post_statistics/hdata_${ipollutant}_${iwhat}_1.Rdata 
    
    outfile=$outdir/post_statistics/hdata_${ipollutant}_1
    Rscript $pdir/post.R \
	$post \
	$outdir/post_statistics/xhdata_${ipollutant}_${iwhat}_1.Rdata \
	$ipollutant \
	$iwhat \
	$outdir/data_${d1}_${d2}_
    
fi







#############################################################################################
if [ "$post" == "hopstat" ] ; then
    echo " Get hopstat_final... "
    outfile=$outdir/post_statistics/hopstat_${ipollutant}_${iwhat}_final
    Rscript $pdir/post.R \
	$post \
	$outdir/data_${d1}_${d2}_ \
	$ipollutant \
	$iwhat \
	$outdir/other/tmp_filestations_all \
	$outfile \
	$outdir/post_statistics/hopdata_${ipollutant}_obs.Rdata \
	$outdir/post_statistics/hopdata_${ipollutant}_${iwhat}.Rdata 

    echo " Get xhopstat_final ... "
    outfile=$outdir/post_statistics/xhopstat_${ipollutant}_${iwhat}_final
    Rscript $pdir/post.R \
	$post \
	$outdir/data_${d1}_${d2}_ \
	$ipollutant \
	$iwhat \
	$outdir/other/tmp_filestations_all \
	$outfile \
	$outdir/post_statistics/xhopdata_${ipollutant}_obs.Rdata \
	$outdir/post_statistics/xhopdata_${ipollutant}_${iwhat}.Rdata 

fi



#############################################################################################
if [[ "$post" == "hfopstat" || "$post" == "hx1errorbinstat" || "$post" == "hx1obsbinstat" ]] ; then
    ## Aggregate statistics on hfopstat/hx1errorbinstat/hx1obsbinstat    (mean,sd,p05-25-50-75-95,min,max,N)
    echo " Aggregate hfopstat/hx1errorbinstat/hx1obsbinstat... "
    outfile=$outdir/post_statistics/${post}_${ipollutant}_${iwhat}
    Rscript $pdir/post.R $post $outdir/data_${d1}_${d2}_ $ipollutant $iwhat $outdir/other/tmp_filestations_all $outfile
fi


#############################################################################################
if [ "$post" == "confusion" ] ; then
    echo " Aggregate confusion matrices... "
    tmpfile=$workdir/tmp_confusion_${ipollutant}_${iwhat}_${itype}
    outfile=$outdir/post_statistics/${post}_${ipollutant}_${iwhat}_${itype}1limstat.csv
    ini=1
    while read -r istation ; do				
	file=$outdir/data_${d1}_${d2}_${istation}/${istation}_${ipollutant}_${iwhat}_${itype}1limstat.csv
	echo "/////////////////////" $file
	if [ -f $file ] ; then
	    #echo ${istation}_${ipollutant}_${iwhat}_${itype}limstat.csv `awk -F',' '{if(NR==2){print $16}}' $file`
	    if [ $ini -eq 1 ] ; then
		awk -F',' '{if(NR>1){print $26,$27,$16,$17,$18,$19}}' $file > $outfile
		ini=0
	    else
		awk -F',' '{if(NR>1){print $26,$27,$16,$17,$18,$19}}' $file > $tmpfile
		paste $outfile $tmpfile | awk '{print $1,$2,($3+$9),($4+$10),($5+$11),($6+$12)}' > ${tmpfile}2
		mv ${tmpfile}2 $outfile
		head -2 $outfile
	    fi
	fi
    done < $outdir/other/tmp_filestations_all
    mv $outfile ${tmpfile}3
    echo "lim1 lim2  H   FA   M   CN" > $outfile 
    cat ${tmpfile}3                  >> $outfile 
    awk '{print $1","$2","$3","$4","$5","$6}' $outfile > $tmpfile
    mv $tmpfile  $outfile  
    rm -f ${tmpfile}*

    head $outfile  

fi

#if [ "$BSC_MACHINE" == "mn4" ] ; then
#    rm -rf $workdir
#fi

echo "  END_job"
