### source('~/scripts/opmos/post_mos.R')

source('~/R/util.R')

print('********************************************************************************')
print('**********************     post.R      *****************************************')
print('********************************************************************************')

print('********** Read first argument')
if(1==1){
    args = commandArgs(TRUE)
    post          <- args[1]
    #print(args)
}




##############################################################################
##                            aggregate1                                    ##
##############################################################################

if(post=="aggregate1a" | post=="aggregate1b"){

    print('********** Read arguments')
    outdir        <- args[2]
    ipollutant    <- args[3]
    iwhat         <- args[4]
    stationfile   <- args[5]
    outfile       <- args[6]
    listrdatafile <- args[7]
    print(paste0('      post          = ',post))
    print(paste0('      outdir        = ',outdir))
    print(paste0('      ipollutant    = ',ipollutant))
    print(paste0('      iwhat         = ',iwhat))
    print(paste0('      outdir        = ',outdir))
    print(paste0('      stationfile   = ',stationfile))
    print(paste0('      outfile       = ',outfile))
    print(paste0('      listrdatafile = ',listrdatafile))    
    
    allstations=read.table(stationfile)[,1]
    nallstations=length(allstations)

    if(post=="aggregate1a"){   
        print('********** Aggregate hopdata.Rdata files')
        rdata <- as.vector(read.table(listrdatafile)[,1])
        nrdata=length(rdata)
        for (i in 1:nrdata){
            load(rdata[i])
            print(rdata[i])
            if(i==1){
                hopdata=save_hopdata
            }else{
                hopdata=rbind(hopdata,save_hopdata)
            }        
        }
        print(dim(hopdata))
        print(object.size(hopdata))
        save_hopdata=hopdata
        save(save_hopdata,file=paste0(outfile,'.Rdata'))
    }
    if(post=="aggregate1b"){   
        print('********** Aggregate hdata.Rdata files')
        rdata <- as.vector(read.table(listrdatafile)[,1])
        nrdata=length(rdata)
        for (i in 1:nrdata){
            load(rdata[i])
            print(rdata[i])
            print(dim(save_hdata))
            
            if(i==1){
                hdata=save_hdata
            }else{            
                hdata=rbind(hdata,save_hdata)
            }        
        }
        print(dim(hdata))
        print(object.size(hdata))
        save_hdata=hdata
        save(save_hdata,file=paste0(outfile,'.Rdata'))
    }
}







##############################################################################
##                            aggregate2                                    ##
##############################################################################
## hopdata_XXX.Rdata => xhopdata_XXX.Rdata (for inter-model comparisons)
## wokfinal : vector identifying the times where all MOS results have data
if(post=="aggregate2a" | post=="aggregate2b"){
    print('**********  Read arguments...')
    rdatafile <- args[2]    
    print(paste0('      post      = ',post))
    print(paste0('      rdatafile = ',rdatafile))
    
    if(post=="aggregate2a"){
        print('**********  Aggregate xhopdata.Rdata files')
        rdata <- as.vector(read.table(rdatafile)[,1])
        nrdata=length(rdata)
        for (i in 1:nrdata){
            load(rdata[i])
            print(rdata[i])
            print(length(which(is.finite(as.matrix(save_hopdata[,1:96]))==TRUE)))        
            wok=which(is.finite(apply(save_hopdata[,1:96],1,sum))==TRUE)
            if(i==1){
                wokfinal=wok
            }else{
                wokfinal=intersect(wok,wokfinal)        
            }
            print(length(wokfinal))        
        }
        for (i in 1:nrdata){
            print(i)
            load(rdata[i])
            print(rdata[i])
            print(dim(save_hopdata))
            save_hopdata=save_hopdata[wokfinal,]
            print(dim(save_hopdata))
            print(length(which(is.finite(as.matrix(save_hopdata[,1:96]))==TRUE)))               
            outputfile=paste0(dirname(rdata[i]),'/x',basename(rdata[i]))
            save(save_hopdata,file=outputfile)
        }
        print(paste('wokfinal : ',length(wokfinal)))    
    }
    if(post=="aggregate2b"){
        print('**********  Aggregate xhdata.Rdata files')
        rdata <- as.vector(read.table(rdatafile)[,1])
        nrdata=length(rdata)
        for (i in 1:nrdata){
            load(rdata[i])
            print(rdata[i])
            print(length(which(is.finite(as.matrix(save_hdata[,3:5]))==TRUE)))        
            wok=which(is.finite(apply(save_hdata[,3:5],1,sum))==TRUE)
            if(i==1){
                wokfinal=wok
            }else{
                wokfinal=intersect(wok,wokfinal)        
            }
            print(length(wokfinal))        
        }
        for (i in 1:nrdata){
            print(i)
            load(rdata[i])
            print(rdata[i])
            print(dim(save_hdata))
            save_hdata=save_hdata[wokfinal,]
            print(dim(save_hdata))
            print(length(which(is.finite(as.matrix(save_hdata[,3:5]))==TRUE)))               
            outputfile=paste0(dirname(rdata[i]),'/x',basename(rdata[i]))
            save(save_hdata,file=outputfile)
        }
        print(paste('wokfinal : ',length(wokfinal)))
    }
}
    


##############################################################################
##                                  xxstat                                  ##
##############################################################################
## => compute hourly statistics for each model and station, based on comparable dataset
if(post=="xxstat"){
    print('**********  Compute comparable statistics for each station')
    print('**********  Read arguments...')
    rdatafile <- args[2]    
    pollutant <- args[3]
    iwhat     <- args[4]
    rootdir   <- args[5]
    print(paste0('      post      =',post))
    print(paste0('      rdatafile =',rdatafile))
    print(paste0('      pollutant =',pollutant))
    print(paste0('      iwhat     =',iwhat))
    print(paste0('      rootdir   =',rootdir))


    print('**********  Compute...')
    print(paste('loading:',rdatafile))
    load(rdatafile)
    print(dim(save_hdata))
    stations=as.vector(unique(save_hdata$station))
    print(paste('Nstations:',length(stations)))
    for (istat in 1:length(stations)){        
        wstat=which(save_hdata$station==stations[istat])
        datatext=c(get_statistics(mode='legend',width=8,sep=',')$cleg,
                   get_statistics(save_hdata$hobs[wstat],save_hdata$hmod[wstat],8,2,sep=',')$cres,
                   get_statistics(save_hdata$hobs[wstat],save_hdata$hmos[wstat],8,2,sep=',')$cres)                                  
        file=paste0(rootdir,stations[istat],'/',stations[istat],'_',pollutant,'_',iwhat,'_hxxstat.csv',sep='')
        con <- file(file,open="w")
        writeLines(datatext[1:length(datatext)], con = con)
        close(con)
        print(paste('writing:',file))
    }
    print('**********  End of xxstat')    
}



##############################################################################
##                                  xxstat                                  ##
##############################################################################
if(post=="hopstat" | post=="hfopstat" | post=='hx1errorbinstat' | post=='hx1obsbinstat'){

    print('********** Read arguments')
    outdir        <- args[2]
    ipollutant    <- args[3]
    iwhat         <- args[4]
    stationfile   <- args[5]
    outfile       <- args[6]   
    print(paste0('      post                    =',post))
    print(paste0('      outdir                  =',outdir))
    print(paste0('      ipollutant              =',ipollutant))
    print(paste0('      iwhat                   =',iwhat))
    print(paste0('      outdir                  =',outdir))
    print(paste0('      stationfile             =',stationfile))
    print(paste0('      outfile                 =',outfile))    
    if(post=="hopstat"){      
        obs_save_hopdata_rdata  <- args[7]   
        what_save_hopdata_rdata <- args[8]   
        print(paste0('      obs_save_hopdata_rdata  =',obs_save_hopdata_rdata))
        print(paste0('      what_save_hopdata_rdata =',what_save_hopdata_rdata))
    }
    
    allstations=read.table(stationfile)[,1]
    nallstations=length(allstations)

    
    if(post=="hopstat"){      
        print('********** Compute statistics on hopdata :stat=f(1-96h)')    
        load(obs_save_hopdata_rdata)  ; obs=save_hopdata
        load(what_save_hopdata_rdata) ; mod=save_hopdata
        print(dim(obs))
        print(dim(mod))
        print(length(which(is.finite(as.matrix(obs[,1:96]))==TRUE)))
        print(length(which(is.finite(as.matrix(mod[,1:96]))==TRUE)))    
        
        nlengthforecast=dim(obs)[2]-2
        hopstat=array(NaN,dim=c(n5seasons,nlengthforecast,nmetrics))
        timeseason=get_season(obs$htime)
        for (isea in 1:n5seasons){
            if(isea<5){
                wsea=which(timeseason==seasons[isea])
            }else{
                wsea=1:length(timeseason)
            }
            if(length(wsea)!=0){
                for (ih in 1:nlengthforecast){
                    hopstat[isea,ih,]=get_statistics(obs[wsea,ih],mod[wsea,ih])$res
                }
            }    
        }

        for (isea in 1:n5seasons){
            if(isea<5){
                wsea=which(timeseason==seasons[isea])
            }else{
                wsea=1:length(timeseason)
            }
            if(length(wsea)!=0){            
                datatext=paste('hour',get_statistics(mode='legend',width=8,sep=',')$cleg,sep=',')
                for (ih in 1:nlengthforecast){
                    datatext=c(datatext,paste(ih,get_statistics(obs[wsea,ih],mod[wsea,ih],7,2,sep=',')$cres,sep=','))
                }
                con <- file(paste0(outfile,'_',seasons5[isea],'.csv'),open="w")
                writeLines(datatext[1:length(datatext)], con = con)
                close(con)
            }
        }
    }

    if(post=="hfopstat"){
        print('********** Get hfopstat')
        ini=1
        for (istat in 1:nallstations){        
            file=paste0(outdir,allstations[istat],'/',allstations[istat],'_',ipollutant,'_',iwhat,'_hfopstat.csv')
            if(file.exists(file)){
                print(paste('OK:',file))
                tab=read.table(file,sep=',',skip=1)
                if(ini==1){
                    dim1=dim(tab)[1]
                    hfopstat_all <- array(NaN,dim=c(nallstations,dim1,nmetrics))
                    ini=0
                }        
                for (im in 1:nmetrics){
                    hfopstat_all[istat,,im] <- tab[,2+im]
                }
            }else{
                print(paste('NO:',file))
            }        
        }

        print('********** Aggregate statistics hfopstat')
        hfopstat <- array(NaN,dim=c(dim1,nmetrics,10))
        for (i in 1:dim1){
            for (im in 1:nmetrics){
                w=which(is.finite(hfopstat_all[,i,im])==TRUE)
                if(length(w)>0){
                    hfopstat[i,im,1] <- meanok(hfopstat_all[w,i,im])
                    if(length(w)>1){hfopstat[i,im,2] <- sdok(hfopstat_all[w,i,im])}
                    hfopstat[i,im,3] <- quantileok(hfopstat_all[w,i,im],0.05)
                    hfopstat[i,im,4] <- quantileok(hfopstat_all[w,i,im],0.25)
                    hfopstat[i,im,5] <- quantileok(hfopstat_all[w,i,im],0.50)
                    hfopstat[i,im,6] <- quantileok(hfopstat_all[w,i,im],0.75)
                    hfopstat[i,im,7] <- quantileok(hfopstat_all[w,i,im],0.95)
                    hfopstat[i,im,8] <- minok(hfopstat_all[w,i,im])
                    hfopstat[i,im,9] <- maxok(hfopstat_all[w,i,im])
                }
                hfopstat[i,im,10] <- length(w)        
            }
        }


        print('********** Write hfopstat results')
        statistics=c('MEAN','SD','P05','P25','P50','P75','P95','MIN','MAX','N')
        column1=c(rep(1,dim1/2),rep(2,dim1/2))
        column2=c(1:(dim1/2),1:(dim1/2))
        for (is in 1:10){
            datatext=paste('mod1mos2,hour',get_statistics(mode='legend',width=8,sep=',')$cleg,sep=',')
            for (i in 1:dim1){        
                linetext=paste(column1[i],column2[i],sep=',')       
                for (im in 1:nmetrics){     
                    linetext=paste(
                        linetext,
                        formatC(hfopstat[i,im,is],digits=2,width=7,format='f',flag=''),sep=',')
                }
                datatext=c(datatext,linetext)
            }
            filename=paste0(outfile,'_',statistics[is],'.csv')
            print(filename)
            con <- file(filename,open="w")
            writeLines(datatext[1:length(datatext)], con = con)
            close(con)
        }
    }


    if(post=='hx1errorbinstat'){
        print('********** Get hx1errorbinstat')
        ini=1
        for (istat in 1:nallstations){        
            file=paste0(outdir,allstations[istat],'/',allstations[istat],'_',ipollutant,'_',iwhat,'_hx1errorbinstat.csv')
            if(file.exists(file)){
                print(paste('OK',file))
                tab=read.table(file,sep=',',skip=1)
                if(ini==1){
                    dim1=dim(tab)[1]
                    hx1errorbinstat_all <- array(NaN,dim=c(nallstations,dim1,nmetrics))
                    lim1=tab[,1]
                    lim2=tab[,2]           
                    ini=0
                }        
                for (im in 1:nmetrics){
                    hx1errorbinstat_all[istat,,im] <- tab[,2+im]
                }
            }else{
                print(paste('NO',file))
            }
        }

        
        print('********** Aggregate statistics hx1errorbinstat')
        hx1errorbinstat <- array(NaN,dim=c(dim1,nmetrics,10))
        for (i in 1:dim1){
            for (im in 1:nmetrics){
                w=which(is.finite(hx1errorbinstat_all[,i,im])==TRUE)
                if(length(w)>0){
                    hx1errorbinstat[i,im,1] <- meanok(hx1errorbinstat_all[w,i,im])
                    if(length(w)>1){hx1errorbinstat[i,im,2] <- sdok(hx1errorbinstat_all[w,i,im])}
                    hx1errorbinstat[i,im,3] <- quantileok(hx1errorbinstat_all[w,i,im],0.05)
                    hx1errorbinstat[i,im,4] <- quantileok(hx1errorbinstat_all[w,i,im],0.25)
                    hx1errorbinstat[i,im,5] <- quantileok(hx1errorbinstat_all[w,i,im],0.50)
                    hx1errorbinstat[i,im,6] <- quantileok(hx1errorbinstat_all[w,i,im],0.75)
                    hx1errorbinstat[i,im,7] <- quantileok(hx1errorbinstat_all[w,i,im],0.95)
                    hx1errorbinstat[i,im,8] <- minok(hx1errorbinstat_all[w,i,im])
                    hx1errorbinstat[i,im,9] <- maxok(hx1errorbinstat_all[w,i,im])
                }
                hx1errorbinstat[i,im,10] <- length(w)        
            }
        }


        print('********** Write hx1errorbinstat results')
        statistics=c('MEAN','SD','P05','P25','P50','P75','P95','MIN','MAX','N')
        column1=c(rep(1,dim1/2),rep(2,dim1/2))
        column2=c(1:(dim1/2),1:(dim1/2))
        for (is in 1:10){
            datatext=paste('lim1,lim2',get_statistics(mode='legend',width=8,sep=',')$cleg,sep=',')
            for (i in 1:dim1){        
                linetext=paste(lim1[i],lim2[i],sep=',')       
                for (im in 1:nmetrics){     
                    linetext=paste(
                        linetext,
                        formatC(hx1errorbinstat[i,im,is],digits=2,width=7,format='f',flag=''),sep=',')
                }
                datatext=c(datatext,linetext)
            }
            filename=paste0(outfile,'_',statistics[is],'.csv')
            print(filename)
            con <- file(filename,open="w")
            writeLines(datatext[1:length(datatext)], con = con)
            close(con)
        } 
    }



    if(post=='hx1obsbinstat'){
        print('********** Get hx1obsbinstat')
        ini=1
        for (istat in 1:nallstations){        
            file=paste0(outdir,allstations[istat],'/',allstations[istat],'_',ipollutant,'_',iwhat,'_hx1obsbinstat.csv')
            if(file.exists(file)){
                print(paste('OK',file))
                tab=read.table(file,sep=',',skip=1)
                if(ini==1){
                    dim1=dim(tab)[1]
                    hx1obsbinstat_all <- array(NaN,dim=c(nallstations,dim1,nmetrics))
                    lim1=tab[,1]
                    lim2=tab[,2]           
                    ini=0
                }        
                for (im in 1:nmetrics){
                    hx1obsbinstat_all[istat,,im] <- tab[,2+im]
                }
            }else{
                print(paste('NO',file))
            }
        }

        
        print('********** Aggregate statistics hx1obsbinstat')
        hx1obsbinstat <- array(NaN,dim=c(dim1,nmetrics,10))
        for (i in 1:dim1){
            for (im in 1:nmetrics){
                w=which(is.finite(hx1obsbinstat_all[,i,im])==TRUE)
                if(length(w)>0){
                    hx1obsbinstat[i,im,1] <- meanok(hx1obsbinstat_all[w,i,im])
                    if(length(w)>1){hx1obsbinstat[i,im,2] <- sdok(hx1obsbinstat_all[w,i,im])}
                    hx1obsbinstat[i,im,3] <- quantileok(hx1obsbinstat_all[w,i,im],0.05)
                    hx1obsbinstat[i,im,4] <- quantileok(hx1obsbinstat_all[w,i,im],0.25)
                    hx1obsbinstat[i,im,5] <- quantileok(hx1obsbinstat_all[w,i,im],0.50)
                    hx1obsbinstat[i,im,6] <- quantileok(hx1obsbinstat_all[w,i,im],0.75)
                    hx1obsbinstat[i,im,7] <- quantileok(hx1obsbinstat_all[w,i,im],0.95)
                    hx1obsbinstat[i,im,8] <- minok(hx1obsbinstat_all[w,i,im])
                    hx1obsbinstat[i,im,9] <- maxok(hx1obsbinstat_all[w,i,im])
                }
                hx1obsbinstat[i,im,10] <- length(w)        
            }
        }


        print('********** Write hx1obsbinstat results')
        statistics=c('MEAN','SD','P05','P25','P50','P75','P95','MIN','MAX','N')
        column1=c(rep(1,dim1/2),rep(2,dim1/2))
        column2=c(1:(dim1/2),1:(dim1/2))
        for (is in 1:10){
            datatext=paste('lim1,lim2',get_statistics(mode='legend',width=8,sep=',')$cleg,sep=',')
            for (i in 1:dim1){        
                linetext=paste(lim1[i],lim2[i],sep=',')       
                for (im in 1:nmetrics){     
                    linetext=paste(
                        linetext,
                        formatC(hx1obsbinstat[i,im,is],digits=2,width=7,format='f',flag=''),sep=',')
                }
                datatext=c(datatext,linetext)
            }
            filename=paste0(outfile,'_',statistics[is],'.csv')
            print(filename)
            con <- file(filename,open="w")
            writeLines(datatext[1:length(datatext)], con = con)
            close(con)
        } 
    }
}

