## OUTPUTS : hopdata,hdata
print('********** Define forecasting parameters')
timestep=24                         #(hours) => at what time step the forecast are launched?
nlate=0                             #(hours) => what is the delay for available observations when the forecast is launched?
nlengthforecast=24*4                #(hours) => how long last the forecast?
nforecast=nhtime/timestep           # => how many forecast are runned over the entire period?
nversions=nlengthforecast/timestep  # => how many different forecast (of different accuracy) are available?
plotdetail=0

print('********** Get hourly data')

###########################################################################
if(what=='obs'){
    
    print('********** Declare variables')
    variables='obs'
    legvariables='Concentration'
    nvariables=length(variables)
    hdata     <- array(NaN,dim=c(nvariables,nhtime,nversions))

    print('********** Get hdata ')
    for (k in 1:nversions){
        hdata[1,,k] <- hobs
    }
   
    print('********** Get hopdata ')
    hopdata <- array(NaN,dim=c(nforecast,nlengthforecast,1))    
    for (i in 1:nforecast){
        itime=(i-1)*timestep
        for (ih in 1:nlengthforecast){
            hopdata[i,ih,1] <- hobs[itime+ih]
        }
    }    
}


###########################################################################
if(what=='mod'){

    print('********** Declare variables')
    if(experiment=='b007'){
        variables=c('mod','ws','wd','pres','ta','pblh')
        legvariables=c('Concentration','WindSpeed','WindDirection','Pressure','Temperature','PBLH')
    }else{
        variables='mod'
        legvariables='Concentration'
    }
    nvariables=length(variables)
    hdata     <- array(NaN,dim=c(nvariables,nhtime,nversions))

    print('********** Get hdata')
    if(experiment=='b007'){
        hws   <- get_hdata('WS'  ,station,htime,'mod',domain,experiment,indir,allstation)
        hwd   <- get_hdata('WD'  ,station,htime,'mod',domain,experiment,indir,allstation)
        hpres <- get_hdata('PRES',station,htime,'mod',domain,experiment,indir,allstation)
        hta   <- get_hdata('TA'  ,station,htime,'mod',domain,experiment,indir,allstation)
        hpblh <- get_hdata('PBLH',station,htime,'mod',domain,experiment,indir,allstation)
    }
    for (k in 1:nversions){
        hdata[1,,k] <- hmod
        if(experiment=='b007'){
            hdata[2,,k] <- hws
            hdata[3,,k] <- hwd
            hdata[4,,k] <- hpres
            hdata[5,,k] <- hta
            hdata[6,,k] <- hpblh
        }
    }   
    
    print('********** Get hopdata ')
    hopdata <- array(NaN,dim=c(nforecast,nlengthforecast,1))    
    for (i in 1:nforecast){
        itime=(i-1)*timestep
        for (ih in 1:nlengthforecast){
            hopdata[i,ih,1] <- hmod[itime+ih]
        }
    }       
} 


###########################################################################
if(what=='kf0'){

    print('********** Declare variables')
    variables=c('mod','corr','error')
    legvariables=c('Concentration','Correction','Error')
    nvariables=length(variables)
    hdata     <- array(NaN,dim=c(nvariables,nhtime,nversions))

    print('********** Get hdata')
    for (k in 1:nversions){
        hdata[1,,k] <- get_hdata(pollutant,station,htime,'kf0',domain,experiment,indir)[1,] 
        hdata[2,,k] <- hdata[1,]-hmod
        hdata[3,,k] <- hdata[1,]-hobs
    }
}



###########################################################################
if(substr(what,1,2)=='ma'){

    print('********** Declare variables')
    variables=paste0(what,c('','corr','error'))
    legvariables=c('Concentration','Correction','Error')
    nvariables=length(variables)
    nwindow=as.numeric(substr(what,3,10))     #(days)        
    
    print('********** Get hopdata')
    hopdata <- array(NaN,dim=c(nforecast,nlengthforecast,nvariables+2))    
    for (i in 1:nforecast){
        itime=(i-1)*timestep
        if((itime+nlengthforecast)<=nhtime){            
            hopdata[i,,nvariables+1]=hobs[itime+1:nlengthforecast]
            hopdata[i,,nvariables+2]=hmod[itime+1:nlengthforecast]       
           
            wprevious=itime-(1:nwindow)*24
            wok=which(wprevious>0 & (itime-wprevious)>nlate)             
            if(length(wok)==nwindow){                
                for (ih in 1:nlengthforecast){
                    w=wprevious[wok]+hour0to24(ih%%timestep)
                    hcorr=meanok(hobs[w]-hmod[w])
                    if(flag_negativeallowed==0){ hopdata[i,ih,1]=max(c(0,hmod[itime+ih]+hcorr)) }
                    if(flag_negativeallowed==1){ hopdata[i,ih,1]=        hmod[itime+ih]+hcorr   }
                    hopdata[i,ih,2]=hcorr
                    hopdata[i,ih,3]=hopdata[i,ih,1]-hobs[itime+ih]                    
                }
            }
        }
    }
   
    print('********** Homogeneize datasets')
    w=which(is.na(hopdata[,,1])==TRUE | is.na(hopdata[,,nvariables+1])==TRUE | is.na(hopdata[,,nvariables+2])==TRUE)
    if(length(w)!=0){
        hopdata[,,1][w]=NaN
        hopdata[,,2][w]=NaN
        hopdata[,,3][w]=NaN
        hopdata[,,nvariables+1][w]=NaN
        hopdata[,,nvariables+2][w]=NaN
    }   
    
    print('********** Get hdata')
    hdata <- array(NaN,dim=c(nvariables,nhtime,nversions))
    for (ivar in 1:nvariables){
        for (i in 1:dim(hopdata)[1]){
            for (k in 1:nversions){
                if(i-k+1 > 0){                                                               
                    hdata[ivar,(i-1)*timestep+1:timestep,k]=hopdata[i-k+1,(k-1)*timestep+1:timestep,ivar]
                }   
            }
        }
    }
}


###########################################################################
if(substr(what,1,3)=='kfs' & substr(what,1,5)!='kfsan'){
    
    print('********** Declare variables')
    variables=paste0(what,c('','corr','error','uncert','gain','wt','vt','woverv'))
    legvariables=c('Concentration','Correction','Error','Uncertainty','Gain','W','V','W/V ratio')    
    nvariables=length(variables)
    hdata    <- array(NaN,dim=c(nvariables,nhtime,nversions))
        
    print('********** Specify parameters')
    configs=c(seq(0.0000001,0.000002,0.0000001),
              seq(0.000001,0.00002,0.000001),
              seq(0.00001,0.0002,0.00001),
              seq(0.0001,0.002,0.0001),
              seq(0.003,0.02,0.001),
              seq(0.03,0.2,0.01),
              seq(0.3,2,0.1),
              seq(3,20,1),
              seq(30,100,10),
              seq(300,1000,100))   
    v_t=1
    x_0_0= 0 
    p_0_0= 5
    nconfigs=length(configs)
    
    print('********** Loop on configs - Get hopdata')
    hdata_all  <- array(NaN,dim=c(nconfigs,nvariables,nhtime))    
    hopdata_all <- array(NaN,dim=c(nconfigs,nforecast,nlengthforecast,nvariables+2))
    for (iconfig in 1:nconfigs){                
        print(paste(iconfig,configs[iconfig]))
        
        ## initialize
        x_tm1_tm1 <- array(x_0_0,dim=timestep)     #(x_0_0)
        p_tm1_tm1 <- array(p_0_0,dim=timestep)     #(p_0_0)               
        x_t_t     <- array(NaN,dim=timestep)     
        p_t_t     <- array(NaN,dim=timestep)     
        k_t       <- array(NaN,dim=timestep)                   
        
        ## loop on time series  
        w_over_v=configs[iconfig]            
        w_t=v_t*w_over_v
        for (i in 1:nforecast){
            itime=(i-1)*timestep
            if(min(itime+1-timestep:1) >= 1 & max(itime+1-timestep:1) <= nhtime & (itime+nlengthforecast)<=nhtime){            
                hopdata_all[iconfig,i,,nvariables+1]=hobs[itime+1:nlengthforecast]
                hopdata_all[iconfig,i,,nvariables+2]=hmod[itime+1:nlengthforecast]

                corr=array(NaN,dim=timestep)
                uncert=array(NaN,dim=timestep)
                gain=array(NaN,dim=timestep)

                y_t=hmod[itime+1-timestep:1]-hobs[itime+1-timestep:1]                                
                for (ih in 1:timestep){                    
                    if(is.na(y_t[ih])==FALSE){                
                        k_t[ih]   <- (p_tm1_tm1[ih] + w_t)/(p_tm1_tm1[ih] + w_t + v_t)                
                        x_t_t[ih] <-  x_tm1_tm1[ih] + k_t[ih]*(y_t[ih] - x_tm1_tm1[ih]) 
                        p_t_t[ih] <- (p_tm1_tm1[ih] + w_t)*(1 - k_t[ih])
                    }else{
                        k_t[ih]   <- 0
                        x_t_t[ih] <- x_tm1_tm1[ih]
                        p_t_t[ih] <- p_tm1_tm1[ih] + w_t
                    }
                    corr[ih]   <- -x_t_t[ih]
                    uncert[ih] <- p_t_t[ih]
                    gain[ih]   <- k_t[ih]                    
                }              
               
                for (ih in 1:nlengthforecast){
                    iih=hour0ton(ih%%timestep,timestep)
                    if(flag_negativeallowed==0){hopdata_all[iconfig,i,ih,1]=max(c(0,hmod[itime+ih]+corr[iih]))}
                    if(flag_negativeallowed==1){hopdata_all[iconfig,i,ih,1]=hmod[itime+ih]+corr[iih]}
                    hopdata_all[iconfig,i,ih,2] <- corr[iih]
                    hopdata_all[iconfig,i,ih,3] <- hopdata_all[iconfig,i,ih,1]-hopdata_all[iconfig,i,ih,nvariables+1]
                    hopdata_all[iconfig,i,ih,4] <- uncert[iih]
                    hopdata_all[iconfig,i,ih,5] <- gain[iih]
                    hopdata_all[iconfig,i,ih,6] <- w_t
                    hopdata_all[iconfig,i,ih,7] <- v_t
                    hopdata_all[iconfig,i,ih,8] <- w_t/v_t
                }
                x_tm1_tm1 <- x_t_t
                p_tm1_tm1 <- p_t_t                                
            }
        }        
    }
      
    print('********** Homogeneize datasets')
    w=which(is.na(hopdata_all[,,,1])==TRUE | is.na(hopdata_all[,,,2])==TRUE | is.na(hopdata_all[,,,3])==TRUE)
    if(length(w)!=0){hopdata_all[w]=NaN}

    print('********** Get hdata')
    print(gc())    
    print(c(nconfigs,nvariables,nhtime,nversions))
    hdata_all <- array(NaN,dim=c(nconfigs,nvariables,nhtime,nversions))
    for (iconfig in 1:nconfigs){                
        for (ivar in 1:nvariables){
            for (i in 1:nforecast){
                for (k in 1:nversions){
                    if(i-k+1 > 0){                                                               
                        hdata_all[iconfig,ivar,(i-1)*timestep+1:timestep,k]=hopdata_all[iconfig,i-k+1,(k-1)*timestep+1:timestep,ivar]
                    }
                }
            }
        }
    }
}







###########################################################################
if(substr(what,1,3)=='kfd'){
    
    print('********** Declare variables')
    variables=paste0(what,c('','corr','error','uncert','gain','wt','vt','woverv'))
    legvariables=c('Concentration','Correction','Error','Uncertainty','Gain','W','V','W/V ratio')    
    nvariables=length(variables)
    hdata    <- array(NaN,dim=c(nvariables,nhtime,nversions))
    
    print('********** Specify parameters')
    configs=5:90 #(ndynwindow)
    timestep=24
    x_0_0= 0 
    p_0_0= 5
    nconfigs=length(configs)    
    
    print('********** Loop on configs')
    hdata_all  <- array(NaN,dim=c(nconfigs,nvariables,nhtime))    
    hopdata_all <- array(NaN,dim=c(nconfigs,nforecast,nlengthforecast,nvariables+2))
    for (iconfig in 1:nconfigs){                
        print(paste(iconfig,configs[iconfig]))        
        ndynwindow=configs[iconfig]
        
        ## initialize
        x_tm1_tm1 <- array(x_0_0,timestep)                 #(x_0_0)
        p_tm1_tm1 <- array(p_0_0,timestep)                 #(p_0_0)               
        x_t_t     <- array(NaN,dim=timestep)     
        p_t_t     <- array(NaN,dim=timestep)     
        k_t       <- array(NaN,dim=timestep)
        last_w_t  <- array(NaN,dim=c(timestep,ndynwindow)) #(last <ndynwindow> values of x_t-x_{t-1})
        last_v_t  <- array(NaN,dim=c(timestep,ndynwindow)) #(last <ndynwindow> values of y_t-x_t)
  
        ## loop on time series  
        for (i in 1:nforecast){
           
            itime=(i-1)*timestep
            if(min(itime+1-timestep:1) >= 1 & max(itime+1-timestep:1) <= nhtime & (itime+nlengthforecast)<=nhtime){            
                hopdata_all[iconfig,i,,nvariables+1]=hobs[itime+1:nlengthforecast]
                hopdata_all[iconfig,i,,nvariables+2]=hmod[itime+1:nlengthforecast]

                corr=array(NaN,dim=timestep)
                uncert=array(NaN,dim=timestep)
                gain=array(NaN,dim=timestep)
                noisev=array(NaN,dim=timestep)
                noisew=array(NaN,dim=timestep)

                y_t=hmod[itime+1-timestep:1]-hobs[itime+1-timestep:1]                                
                for (itimestep in 1:timestep){
   
                    if(is.na(sdok(last_v_t[itimestep,]))==FALSE & is.na(sdok(last_w_t[itimestep,]))==FALSE){                                                     
                        v_t = 1/(ndynwindow-1)*sumok( ((last_v_t[itimestep,])-meanok(last_v_t[itimestep,]))^2)
                        w_t = 1/(ndynwindow-1)*sumok( ((last_w_t[itimestep,])-meanok(last_w_t[itimestep,]))^2)                    
                    }else{
                        v_t=1
                        w_t=v_t*0.01
                    }
                    
                    y_t=hmod[itime-timestep+itimestep]-hobs[itime-timestep+itimestep]                                
                    if(is.na(y_t)==FALSE){                
                        k_t[itimestep]   <- (p_tm1_tm1[itimestep] + w_t)/(p_tm1_tm1[itimestep] + w_t + v_t)                
                        x_t_t[itimestep] <-  x_tm1_tm1[itimestep] + k_t[itimestep]*(y_t - x_tm1_tm1[itimestep]) 
                        p_t_t[itimestep] <- (p_tm1_tm1[itimestep] + w_t)*(1 - k_t[itimestep])
                    }else{
                        k_t[itimestep]   <- 0
                        x_t_t[itimestep] <- x_tm1_tm1[itimestep]
                        p_t_t[itimestep] <- p_tm1_tm1[itimestep] + w_t
                    }
                    
                    corr[itimestep]   <- -x_t_t[itimestep]
                    uncert[itimestep] <- p_t_t[itimestep]
                    gain[itimestep]   <- k_t[itimestep]
                    noisev[itimestep] <- v_t
                    noisew[itimestep] <- w_t

                    last_v_t[itimestep,]=c(y_t-x_tm1_tm1[itimestep]  ,last_v_t[itimestep,1:(ndynwindow-1)])
                    last_w_t[itimestep,]=c(x_t_t[itimestep]-x_tm1_tm1[itimestep],last_w_t[itimestep,1:(ndynwindow-1)])
                    
                    p_tm1_tm1[itimestep]=p_t_t[itimestep]
                    x_tm1_tm1[itimestep]=x_t_t[itimestep]
                }                            

                for (ih in 1:nlengthforecast){
                    iih=hour0ton(ih%%timestep,timestep)
                    if(flag_negativeallowed==0){hopdata_all[iconfig,i,ih,1]=max(c(0,hmod[itime+ih]+corr[iih]))}
                    if(flag_negativeallowed==1){hopdata_all[iconfig,i,ih,1]=hmod[itime+ih]+corr[iih]}
                    hopdata_all[iconfig,i,ih,2] <- corr[iih]
                    hopdata_all[iconfig,i,ih,3] <- hopdata_all[iconfig,i,ih,1]-hopdata_all[iconfig,i,ih,nvariables+1]
                    hopdata_all[iconfig,i,ih,4] <- uncert[iih]
                    hopdata_all[iconfig,i,ih,5] <- gain[iih]
                    hopdata_all[iconfig,i,ih,6] <- noisew[iih]
                    hopdata_all[iconfig,i,ih,7] <- noisev[iih]
                    hopdata_all[iconfig,i,ih,8] <- noisew[iih]/noisev[iih]
                }                          
            }
        }                 
    }
        
    print('********** Homogeneize datasets')
    w=which(is.na(hopdata_all[,,,1])==TRUE | is.na(hopdata_all[,,,2])==TRUE | is.na(hopdata_all[,,,3])==TRUE)
    if(length(w)!=0){hopdata_all[w]=NaN}

    print('********** Get hdata')
    hdata_all <- array(NaN,dim=c(nconfigs,nvariables,nhtime,nversions))
    for (iconfig in 1:nconfigs){                
        for (ivar in 1:nvariables){
            for (i in 1:nforecast){
                for (k in 1:nversions){
                    if(i-k+1 > 0){                                                               
                        hdata_all[iconfig,ivar,(i-1)*timestep+1:timestep,k]=hopdata_all[iconfig,i-k+1,(k-1)*timestep+1:timestep,ivar]
                    }
                }
            }
        }
    }    
}






###########################################################################
if(substr(what,1,2)=='an'){

    print('********** Declare variables')
    variables=paste0(what,c('','std','_weighted','sd_weighted','corr','error'))
    legvariables=c('Concentration','Standard deviation','Concentration (weighted)','Standard deviation (weighted)','Correction','Error')
    nvariables=length(variables)
    hdata    <- array(NaN,dim=c(nvariables,nhtime,nversions))

    print('********** Specify parameters')
    configs=10    #(number of analogs)
    nconfigs=length(configs)    
    if(substr(what,1,3)=='an-'){method=substr(what,4,100)}
    method=gsub('RMSE','',method)
    method=gsub('PCC','',method)
    timestep=24
    nanwindow=45
    hdata_all  <- array(NaN,dim=c(nconfigs,nvariables,nhtime))
    
    print('********** Check existence of features')
    ok=1
    anvar=unlist(strsplit(method,'_'))
    nanvar=length(anvar)                    
    for (ivar in 1:nanvar){
        n=length(unlist(strsplit(anvar[ivar],'-')))
        
        if(n >= 1){var    =            unlist(strsplit(anvar[ivar],'-'))[1] }
        if(n >= 2){nhour  = as.numeric(unlist(strsplit(anvar[ivar],'-'))[2])}else{nhour=0}
        if(n >= 3){weight = as.numeric(unlist(strsplit(anvar[ivar],'-'))[3])}else{weight=1}         
        
        if(var=='C'){val=hmod}
        if(var=='S'){hws   <- get_hdata('WS'  ,station,htime,'mod',domain,experiment,indir,allstation) ; if(all(is.na(hws  ))){ok=0 ; print('WS missing...')}}
        if(var=='D'){hwd   <- get_hdata('WD'  ,station,htime,'mod',domain,experiment,indir,allstation) ; if(all(is.na(hwd  ))){ok=0 ; print('WD missing...')}}
        if(var=='P'){hpres <- get_hdata('PRES',station,htime,'mod',domain,experiment,indir,allstation) ; if(all(is.na(hpres))){ok=0 ; print('PRES missing...')}}
        if(var=='T'){hta   <- get_hdata('TA'  ,station,htime,'mod',domain,experiment,indir,allstation) ; if(all(is.na(hta  ))){ok=0 ; print('TA missing...')}}
        if(var=='H'){hpblh <- get_hdata('PBLH',station,htime,'mod',domain,experiment,indir,allstation) ; if(all(is.na(hpblh))){ok=0 ; print('PBLH missing...')}}        
    }      
    
    hopdata_all <- array(NaN,dim=c(nconfigs,nforecast,nlengthforecast,nvariables+2))
    if(ok==1){        
        if(plotdetail==1){
            figout=paste0(workdir,'/',outputfile,'_detail.pdf',sep='')
            pdf(figout,width=15,height=20,paper='a4r')
            cex=1.2
            lwd=3
            par(mar=c(4,4,1.5,1.5),mfrow=c(2,1),cex=cex,cex.axis=cex,cex.lab=cex,cex.main=cex)
        }

        print('********** Loop on configs - Get hopdata')   
        for (iconfig in 1:nconfigs){
            nanalogs=configs[iconfig]
            for (i in (nanalogs+1):nforecast){
                print(c(iconfig,i))
                itime=(i-1)*timestep
                if(min(itime+1-timestep:1) >= 1 & max(itime+1-timestep:1) <= nhtime & (itime+nlengthforecast)<=nhtime){            
                    hopdata_all[iconfig,i,,nvariables+1]=hobs[itime+1:nlengthforecast]
                    hopdata_all[iconfig,i,,nvariables+2]=hmod[itime+1:nlengthforecast]
                    
                    for (ih in 1:nlengthforecast){

                        itimestep=hour0ton(ih%%timestep,timestep) 

                        ## define dates where to search for analogs                        
                        witimestep=0:(i-2)*24+itimestep
                        witimestepp1=0:(i-1)*24+itimestep
                        w=which(as.numeric(difftime(htime[itime+ih],htime[witimestep],units='days'))%%365 <= nanwindow)
                        witimestep=witimestep[w]                       
                        
                        ## compute distance metric for all points
                        anvar=unlist(strsplit(method,'_'))
                        nanvar=length(anvar)                    
                        andistance=array(0,dim=length(witimestep))                        
                        ini=1
                        for (ivar in 1:nanvar){
                            n=length(unlist(strsplit(anvar[ivar],'-')))
                            
                            if(n >= 1){var    =            unlist(strsplit(anvar[ivar],'-'))[1] }
                            if(n >= 2){nhour  = as.numeric(unlist(strsplit(anvar[ivar],'-'))[2])}else{nhour=0}
                            if(n >= 3){weight = as.numeric(unlist(strsplit(anvar[ivar],'-'))[3])}else{weight=1}         
                            
                            if(var=='C'){val=hmod}
                            if(var=='S'){val=hws}
                            if(var=='D'){val=hwd}
                            if(var=='P'){val=hpres}
                            if(var=='T'){val=hta}
                            if(var=='H'){val=hpblh}

                            wok=which(witimestep-nhour>0 & witimestep+nhour <= length(hmod))
                            if(length(wok)==0){
                                ok=0
                            }else{
                                witimestepok=witimestep[wok]
                                witimestepp1ok=witimestepp1[wok]
                                if(ini==1){andistance=array(0,dim=length(witimestepok));ini=0}                                                
                                
                                if(min(witimestepok-nhour) > 0 & max(witimestepok+nhour) <= length(hmod)){
                                    tmp=array(0,dim=length(witimestepok))
                                    for (j in -nhour:nhour){
                                        tmp <- tmp + 1/sdok(val)^2*(val[witimestepok+j]-val[itime+ih+j])^2
                                    }
                                    andistance <- andistance + weight*sqrt(tmp)
                                    ok=1
                                }else{
                                    ok=0                                  
                                }
                            }
                        }                      
                        
                        if(0==1 & i==(nanalogs+1)){
                            print('-------------')
                            print(c(i,itime,ih,itimestep))
                            print(witimestep)                            
                        }
                        
                        ## select analogs
                        if(ok==1){
                            weight=1/andistance/(sumok(1/andistance))
                            worder=order(andistance,decreasing=FALSE)
                            worder=worder[max(c(length(worder)-nanwindow,1)):length(worder)]                        
                            w=which(!is.na(hobs[witimestep[worder]]))
                            if(length(w) >= nanalogs){
                                w=w[1:nanalogs]
                                worder=worder[w]                        
                                anforecast=meanok(hobs[witimestepok[worder]])                   
                                
                                hopdata_all[iconfig,i,ih,1] <- anforecast
                                hopdata_all[iconfig,i,ih,2] <- sdok(hobs[witimestepok[worder]])
                                hopdata_all[iconfig,i,ih,3] <- wt.mean(hobs[witimestepok[worder]],weight[worder])
                                hopdata_all[iconfig,i,ih,4] <- wt.sd(hobs[witimestepok[worder]],weight[worder])                              
                                hopdata_all[iconfig,i,ih,5] <-  hopdata_all[iconfig,i,ih,1]-hopdata_all[iconfig,i,ih,nvariables+2]
                                hopdata_all[iconfig,i,ih,6] <-  hopdata_all[iconfig,i,ih,1]-hopdata_all[iconfig,i,ih,nvariables+1]
                            }
                        }
                    }
                }
            }
        }     
        if(plotdetail==1){
            print(figout)
            dev.off()
        }
    }
  
    print('********** Homogeneize datasets')
    w=which(is.na(hopdata_all[,,,1])==TRUE | is.na(hopdata_all[,,,2])==TRUE | is.na(hopdata_all[,,,3])==TRUE)
    if(length(w)!=0){hopdata_all[w]=NaN}
    
    print('********** Get hdata')
    hdata_all <- array(NaN,dim=c(nconfigs,nvariables,nhtime,nversions))
    for (iconfig in 1:nconfigs){                
        for (ivar in 1:(nvariables)){
            for (i in 1:nforecast){
                for (k in 1:nversions){
                    if(i-k+1 > 0){                                                               
                        hdata_all[iconfig,ivar,(i-1)*timestep+1:timestep,k] = hopdata_all[iconfig,i-k+1,(k-1)*timestep+1:timestep,ivar]
                    }
                }
            }
        }
    }    
}







###########################################################################
if(substr(what,1,5)=='kfsan'){
    
    print('KFSAN!!')
    print('********** Declare variables')
    variables=paste0(what,c('','corr','error','uncert','gain','wt','vt','woverv'))
    legvariables=c('Concentration','Correction','Error','Uncertainty','Gain','W','V','W/V ratio')    
    nvariables=length(variables)
    hdata    <- array(NaN,dim=c(nvariables,nhtime,nversions))
    
    print('********** Specify parameters')
    method='RMSE'
    timestep=24
    nanwindow=45 
    configs=c(seq(0.0000001,0.000002,0.0000001),
              seq(0.000001,0.00002,0.000001),
              seq(0.00001,0.0002,0.00001),
              seq(0.0001,0.002,0.0001),
              seq(0.003,0.02,0.001),
              seq(0.03,0.2,0.01),
              seq(0.3,2,0.1),
              seq(3,20,1),
              seq(30,100,10),
              seq(300,1000,100)) 
    configs=c(0.001,0.005,0.01,0.05,0.1,0.5,1) ## hervetmp 
   
    nconfigs=length(configs)    
    hdata_all  <- array(NaN,dim=c(nconfigs,nvariables,nhtime))
    if(substr(what,1,6)=='kfsan-'){method=substr(what,7,100)}
    method=gsub('RMSE','',method)
    method=gsub('PCC','',method)
    print(paste('what/method',what,method))
    
    print('********** Check existence of features')
    ok=1
    anvar=unlist(strsplit(method,'_'))
    nanvar=length(anvar)                    
    for (ivar in 1:nanvar){
        n=length(unlist(strsplit(anvar[ivar],'-')))
        
        if(n >= 1){var    =            unlist(strsplit(anvar[ivar],'-'))[1] }
        if(n >= 2){nhour  = as.numeric(unlist(strsplit(anvar[ivar],'-'))[2])}else{nhour=0}
        if(n >= 3){weight = as.numeric(unlist(strsplit(anvar[ivar],'-'))[3])}else{weight=1}         
        
        if(var=='C'){val=hmod}
        if(var=='S'){hws   <- get_hdata('WS'  ,station,htime,'mod',domain,experiment,indir) ; if(all(is.na(hws  ))){ok=0}}
        if(var=='D'){hwd   <- get_hdata('WD'  ,station,htime,'mod',domain,experiment,indir) ; if(all(is.na(hwd  ))){ok=0}}
        if(var=='P'){hpres <- get_hdata('PRES',station,htime,'mod',domain,experiment,indir) ; if(all(is.na(hpres))){ok=0}}
        if(var=='T'){hta   <- get_hdata('TA'  ,station,htime,'mod',domain,experiment,indir) ; if(all(is.na(hta  ))){ok=0}}
        if(var=='H'){hpblh <- get_hdata('PBLH',station,htime,'mod',domain,experiment,indir) ; if(all(is.na(hpblh))){ok=0}}
    }


       print('********** Loop on configs - Get hopdata')   
    hopdata_all <- array(NaN,dim=c(nconfigs,nforecast,nlengthforecast,nvariables+2))
    for (iconfig in 1:nconfigs){         
        for (i in 1:nforecast){
           # for (i in 1:150){
            
            print(c(iconfig,configs[iconfig],i)) 
            itime=(i-1)*timestep
            if(min(itime+1-timestep:1) >= 1 & max(itime+1-timestep:1) <= nhtime & (itime+nlengthforecast)<=nhtime){            
                hopdata_all[iconfig,i,,nvariables+1]=hobs[itime+1:nlengthforecast]
                hopdata_all[iconfig,i,,nvariables+2]=hmod[itime+1:nlengthforecast]
                
                for (ih in 1:nlengthforecast){
                    
                    itimestep=hour0ton(ih%%timestep,timestep) 

                    ## define dates where to search for analogs                        
                    witimestep=0:(i-2)*24+itimestep
                    witimestepp1=0:(i-1)*24+itimestep
                    diff=as.numeric(difftime(htime[itime+itimestep],htime[witimestep],units='days'))%%365
                    w=which(diff <= nanwindow | diff >= (365-nanwindow))
                    witimestep=witimestep[w]                       

                    ok=0
                    if(length(w) >= nanwindow){
                        
                        ## compute distance metric for all points                        
                        anvar=unlist(strsplit(method,'_'))
                        nanvar=length(anvar)                    
                        ini=1
                        for (ivar in 1:nanvar){
                            n=length(unlist(strsplit(anvar[ivar],'-')))                            
                            if(n >= 1){var    =            unlist(strsplit(anvar[ivar],'-'))[1] }
                            if(n >= 2){nhour  = as.numeric(unlist(strsplit(anvar[ivar],'-'))[2])}else{nhour=0}
                            if(n >= 3){weight = as.numeric(unlist(strsplit(anvar[ivar],'-'))[3])}else{weight=1}         
                            
                            if(var=='C'){val=hmod}
                            if(var=='S'){val=hws}
                            if(var=='D'){val=hwd}
                            if(var=='P'){val=hpres}
                            if(var=='T'){val=hta}
                            if(var=='H'){val=hpblh}

                            wok=which(witimestep-nhour>0 & witimestep+nhour <= length(hmod))
                            if(length(wok)==0){
                                ok=0
                            }else{                                
                                witimestepok=witimestep[wok]
                                witimestepp1ok=witimestepp1[wok]
                                if(ini==1){andistance=array(0,dim=length(witimestepok));ini=0}                                                
                                if(min(witimestep-nhour) > 0 & max(witimestep+nhour) <= length(hmod)){
                                    tmp=array(0,dim=length(witimestepok))
                                    for (j in -nhour:nhour){
                                        tmp <- tmp + 1/sdok(val[1:itime])^2*(val[witimestepok+j]-val[itime+ih+j])^2                                   
                                    }
                                    andistance <- andistance + weight*sqrt(tmp)
                                    ok=1
                                }else{
                                    ok=0                                  
                                }
                            }               
                        }
                    }
                    if(0==1 & ok==1){
                        print('//////////////////')
                        print(what)
                        print(andistance)
                        her
                    }                                    
                    
                    ## select analogs
                    if(ok==1){
                        weight=1/andistance/(sumok(1/andistance))
                        worder=rev(order(andistance,decreasing=FALSE))
                        worder=worder[max(c(length(worder)-nanwindow,1)):length(worder)]                           
                        hanmod=hmod[witimestepok][worder]
                        hanobs=hobs[witimestepok][worder]
                        
                        ## initialize
                        v_t=1
                        x_0_0=0 
                        p_0_0=5
                        x_tm1_tm1=x_0_0   
                        p_tm1_tm1=p_0_0   

                        ## loop on (short) analog time series  
                        w_over_v=configs[iconfig]            
                        w_t=v_t*w_over_v
                        
                        check=array(NaN,dim=c(length(worder),5))
                        for (j in 1:length(worder)){                            
                            y_t=hanmod[j]-hanobs[j]
                            if(is.na(y_t)==FALSE){                
                                k_t   <- (p_tm1_tm1 + w_t)/(p_tm1_tm1 + w_t + v_t)                
                                x_t_t <-  x_tm1_tm1 + k_t*(y_t - x_tm1_tm1) 
                                p_t_t <- (p_tm1_tm1 + w_t)*(1 - k_t)
                            }else{
                                k_t   <- 0
                                x_t_t <- x_tm1_tm1
                                p_t_t <- p_tm1_tm1 + w_t
                            }
                            
                            check[j,1]=x_t_t
                            check[j,2]=p_t_t
                            check[j,3]=x_tm1_tm1
                            check[j,4]=p_tm1_tm1
                            check[j,5]=k_t
                            
                            x_tm1_tm1 <- x_t_t
                            p_tm1_tm1 <- p_t_t                            
                        }                            
                        
                        if(flag_negativeallowed==0){hopdata_all[iconfig,i,ih,1]=max(c(0,hmod[itime+ih]-x_t_t))}
                        if(flag_negativeallowed==1){hopdata_all[iconfig,i,ih,1]=hmod[itime+ih]-x_t_t}
                        hopdata_all[iconfig,i,ih,2] <- -x_t_t
                        hopdata_all[iconfig,i,ih,3] <- hopdata_all[iconfig,i,ih,1]-hopdata_all[iconfig,i,ih,nvariables+1]
                        hopdata_all[iconfig,i,ih,4] <- p_t_t
                        hopdata_all[iconfig,i,ih,5] <- k_t
                        hopdata_all[iconfig,i,ih,6] <- w_t
                        hopdata_all[iconfig,i,ih,7] <- v_t
                        hopdata_all[iconfig,i,ih,8] <- w_t/v_t

                        if(plotdetail==1 & ih==1){                          
                            
                            par(mar=c(5,5,2,2),mfrow=c(3,2))
                            layout(matrix(c(1,2,3,
                                            4,4,4,
                                            5,5,5,
                                            6,6,6),4,3,byrow=TRUE))                            
                            main=paste(formatC(hmod[itime+ih],digits=1,width=1,format="f",flag=" "),
                                       formatC(hobs[itime+ih],digits=1,width=1,format="f",flag=" "),
                                       formatC(x_t_t,digits=1,width=1,format="f",flag=" "),
                                       formatC(hopdata_all[iconfig,i,ih,1]-hopdata_all[iconfig,i,ih,nvariables+1],digits=1,width=1,format="f",flag=" "),sep='/')
                            plot(1:length(worder),check[,1],type='b',col='red',main=paste(i,'/',itime),xlab='',ylab='x_t_t')
                            grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
                            plot(1:length(worder),check[,2],type='b',col='red',main=main,xlab='',ylab='P_t_t')
                            grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
                            plot(1:length(worder),check[,5],type='b',col='red',xlab='',ylab='k_t')
                            grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)

                            ylim=c(0,130)
                            if(is.finite(maxok(ylim))==TRUE){
                                plot(1:length(witimestep),hmod[witimestep],type='n',ylim=ylim,main='Normal time series')
                                grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
                                points(1:length(witimestep),hmod[witimestep],type='b',col='red')
                                points(1:length(witimestep),hobs[witimestep],type='b')                                
                                points(c(-1,1)*1e9,c(0,0)+hmod[itime+ih],type='l',col='red',lwd=2)                                
                                points(c(-1,1)*1e9,c(0,0)+hmod[itime+ih]-x_t_t,type='l',col='green',lwd=2)                                
                           } 
                            if(is.finite(maxok(ylim))==TRUE){
                                plot(1:length(witimestep[worder]),hmod[witimestep][worder],type='n',ylim=ylim,main='Ordered time series')
                                grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
                                points(1:length(witimestep[worder]),hmod[witimestep][worder],type='b',col='red')
                                points(1:length(witimestep[worder]),hobs[witimestep][worder],type='b')                                
                                points(c(-1,1)*1e9,c(0,0)+hmod[itime+ih],type='l',col='red',lwd=2)
                                points(c(-1,1)*1e9,c(0,0)+hmod[itime+ih]-x_t_t,type='l',col='green',lwd=2)                                
                            } 

                            if(max(witimestepp1) <= length(hmod)){
                                if(is.finite(maxok(ylim))==TRUE){
                                    plot(1:length(witimestepp1),hmod[witimestepp1],type='b',col='red',ylim=ylim,main='Normal time series +1 day')
                                    grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
                                    points(1:length(witimestepp1),hobs[witimestepp1],type='b')

                                    points(1:length(witimestepp1),hopdata_all[iconfig,1:i,ih,1],type='p',pch=16,col='green',cex=2)
                                   
                                    points(length(witimestepp1),hmod[itime+ih],type='p',pch=16,col='red',cex=3)
                                    points(length(witimestepp1),hmod[itime+ih]-x_t_t,type='p',pch=16,col='green',cex=3)
                                    points(c(-1,1)*1e9,c(0,0)+hmod[itime+ih],type='l',col='red',lwd=2)
                                    points(c(-1,1)*1e9,c(0,0)+hmod[itime+ih]-x_t_t,type='l',col='green',lwd=2)   
                                    
                                }
                            }                            
                        }
                    }                    
                }
            }                   
        }        
    }
    
     
    print('********** Homogeneize datasets')
    w=which(is.na(hopdata_all[,,,1])==TRUE | is.na(hopdata_all[,,,2])==TRUE | is.na(hopdata_all[,,,3])==TRUE)
    if(length(w)!=0){hopdata_all[w]=NaN}

    print('********** Get hdata')
    hdata_all <- array(NaN,dim=c(nconfigs,nvariables,nhtime,nversions))
    for (iconfig in 1:nconfigs){                
        for (ivar in 1:nvariables){
            for (i in 1:nforecast){
                for (k in 1:nversions){
                    if(i-k+1 > 0){                                                               
                        hdata_all[iconfig,ivar,(i-1)*timestep+1:timestep,k]=hopdata_all[iconfig,i-k+1,(k-1)*timestep+1:timestep,ivar]
                    }
                }
            }
        }
    }    
}



###########################################################################
if(substr(what,1,2)=='ml'){
    
    print('********** Declare variables')
    variables=what
    legvariables='Concentration'
    nvariables=length(variables)
    hdata    <- array(NaN,dim=c(nvariables,nhtime,nversions))

    if(1==1 & experiment=='b007'){
        hws   <- get_hdata('WS'  ,station,htime,'mod',domain,experiment,indir,allstation)
        hwd   <- get_hdata('WD'  ,station,htime,'mod',domain,experiment,indir,allstation)
        hpres <- get_hdata('PRES',station,htime,'mod',domain,experiment,indir,allstation)
        hta   <- get_hdata('TA'  ,station,htime,'mod',domain,experiment,indir,allstation)
        hpblh <- get_hdata('PBLH',station,htime,'mod',domain,experiment,indir,allstation)    
    }

    print('********** Get ML options')
    tmp=unlist(strsplit(substr(what,4,999),'-'))   
    configs=tmp[1]   
    imin=as.numeric(tmp[2])
    ifreq=as.numeric(tmp[3])
    configtarget=as.numeric(tmp[4])
    configvar=as.numeric(tmp[5])
    configtrain=as.numeric(tmp[6])
    
    
    nconfigs=length(configs)   
    
    if(substr(configs,1,3)=='gbm'){
        library(gbm)
        library(pdp)
        library(geosphere)
    }
    
    print('********** Get multistations training dataset')
    if(multistattraining==1){
                                        #trainingstation=c('ES1422A','ES1943A','ES1938A','ES1944A','ES1942A','ES1941A','ES1937A','ES1525A','ES1426A','ES1947A','ES2028A') #URB-MAD
        
        print('********** Find near-by similar stations')  
        allstations=as.vector(read.table(paste0(stationsdir,'stations_ALL'))[,1])
        coordstation=get_infostat(station)[1,]
        coordallstations=get_infostat(allstations)
        dist <- array(NaN,dim=length(allstations))
        for (istat in 1:length(allstations)){
            dist[istat]=distHaversine(c(coordallstations[istat,1],coordallstations[istat,2]),c(coordstation[1],coordstation[2]))/1000
        }
        wstat=which(coordallstations[,4]==coordstation[4] & dist <= 100 & dist!=0)
        if(length(wstat)!=0){
            wstat=wstat[1:min(c(5,length(wstat)))]
            trainingstation=allstations[wstat]
        }else{
            trainingstation=station
        }        
        print(trainingstation)        
             
        xtrainingtarget    <- NaN
        xtraininghmod      <- NaN
        xtrainingherrorm24   <- NaN 
        xtrainingherrorm48   <- NaN 
        xtraininghmodm24     <- NaN 
        xtraininghmodm48     <- NaN 
        xtrainingherrorm1    <- NaN 
        xtrainingherrorm2    <- NaN 
        xtrainingherrorm3    <- NaN 
        xtrainingherrorm4    <- NaN 
        xtrainingherrorm5    <- NaN 
        xtrainingherrorm6    <- NaN 
        xtraininghws        <- NaN 
        xtraininghwd        <- NaN 
        xtraininghpres      <- NaN 
        xtraininghta        <- NaN 
        xtraininghpblh      <- NaN 
        xtrainingrandom     <- NaN
        xtraininghour       <- NaN 
        xtraininghpblhm1      <- NaN
        xtraininghpblhp1      <- NaN
        xtraininghtam1        <- NaN
        xtraininghtap1        <- NaN 
        xtraininghpblh_d1   <- NaN 
        xtraininghta_d1     <- NaN 
        xtraininghws_d1     <- NaN 
        xtraininghwd_d1     <- NaN 
        xtraininghpres_d1   <- NaN 
        for (istat in 1:length(trainingstation)){
            res <- get_hdata(pollutant,trainingstation[istat],htime,c('obs','mod'),domain,experiment,indir,allstation)
            hhobs <- res[1,]
            hhmod <- res[2,]
            if(experiment=='b007'){
                w=which(hhmod==0)
                if(length(w)!=0){hhmod[w]=hhmod[w+1]}  ## herve tmp !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            }
            if(length(which(is.finite(hhobs)==TRUE & is.finite(hhmod)==TRUE))!=0){
                
                hhws   <- get_hdata('WS'  ,trainingstation[istat],htime,'mod',domain,experiment,indir,allstation)
                hhwd   <- get_hdata('WD'  ,trainingstation[istat],htime,'mod',domain,experiment,indir,allstation)
                hhpres <- get_hdata('PRES',trainingstation[istat],htime,'mod',domain,experiment,indir,allstation)
                hhta   <- get_hdata('TA'  ,trainingstation[istat],htime,'mod',domain,experiment,indir,allstation)
                hhpblh <- get_hdata('PBLH',trainingstation[istat],htime,'mod',domain,experiment,indir,allstation)
                
                wtime=(24*2+1):length(hhobs)                 

                diff=100*(meanok(hhobs[wtime])-meanok(hobs[wtime]))/meanok(hobs[wtime])
                if(abs(diff) <= 20){
                    
                    if(configtarget==0){xtrainingtarget <- c(xtrainingtarget,             hhobs[wtime])}
                    if(configtarget==1){xtrainingtarget <- c(xtrainingtarget,hhmod[wtime]-hhobs[wtime])}
                    
                    xtraininghmod      <- c(xtraininghmod,hhmod[wtime])
                    xtrainingherrorm24   <- c(xtrainingherrorm24,hhmod[wtime-24]-hhobs[wtime-24])
                    xtrainingherrorm48   <- c(xtrainingherrorm48,hhmod[wtime-48]-hhobs[wtime-48])
                    xtraininghmodm24   <- c(xtraininghmodm24,hhmod[wtime-24])
                    xtraininghmodm48   <- c(xtraininghmodm48,hhmod[wtime-48])       
                    xtrainingherrorm1    <- c(xtrainingherrorm1,hhmod[wtime-1]-hhobs[wtime-1])
                    xtrainingherrorm2    <- c(xtrainingherrorm2,hhmod[wtime-2]-hhobs[wtime-2])
                    xtrainingherrorm3    <- c(xtrainingherrorm3,hhmod[wtime-3]-hhobs[wtime-3])
                    xtrainingherrorm4    <- c(xtrainingherrorm4,hhmod[wtime-4]-hhobs[wtime-4])
                    xtrainingherrorm5    <- c(xtrainingherrorm5,hhmod[wtime-5]-hhobs[wtime-5])
                    xtrainingherrorm6    <- c(xtrainingherrorm6,hhmod[wtime-6]-hhobs[wtime-6])
                    xtraininghws        <- c(xtraininghws,hhws[wtime])
                    xtraininghwd        <- c(xtraininghwd,hhwd[wtime])
                    xtraininghpres      <- c(xtraininghpres,hhpres[wtime])
                    xtraininghta        <- c(xtraininghta,hhta[wtime])
                    xtraininghpblh      <- c(xtraininghpblh,hhpblh[wtime])
                    xtrainingrandom     <- c(xtrainingrandom,runif(length(wtime),0,10))
                    xtraininghour       <- c(xtraininghour,hour0to24(wtime%%24))
                    xtraininghpblhm1    <- c(xtraininghpblhm1,hhpblh[wtime-1])
                    xtraininghpblhp1    <- c(xtraininghpblhp1,hhpblh[wtime+1])
                    xtraininghtam1      <- c(xtraininghtam1,hhta[wtime-1])
                    xtraininghtap1      <- c(xtraininghtap1,hhta[wtime+1])    
                    xtraininghpblh_d1   <- c(xtraininghpblh_d1,hhpblh[wtime]-hhpblh[wtime-3])
                    xtraininghta_d1     <- c(xtraininghta_d1,hhta[wtime]-hhta[wtime-3])
                    xtraininghws_d1     <- c(xtraininghws_d1,hhws[wtime]-hhws[wtime-3])
                    xtraininghwd_d1     <- c(xtraininghwd_d1,hhwd[wtime]-hhwd[wtime-3])
                    xtraininghpres_d1   <- c(xtraininghpres_d1,hhpres[wtime]-hhpres[wtime-3])
                }
            }
        }
        if(configvar==0){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtrainingherrorm24)}
        if(configvar==1){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtraininghws,xtraininghwd,xtraininghpres,xtraininghta,xtraininghpblh)}
        if(configvar==11){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtraininghws,xtraininghwd,xtraininghpres,xtraininghta,xtraininghpblh,xtraininghour)}
        if(configvar==2){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtraininghws,xtraininghwd,xtraininghpres,xtraininghta,xtraininghpblh,
                                              xtraininghpblh_d1,xtraininghta_d1,xtraininghws_d1,xtraininghwd_d1,xtraininghpres_d1)}
        if(configvar==3){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtraininghws,xtraininghwd,xtraininghpres,xtraininghta,xtraininghpblh,
                                              xtraininghpblh_d1,xtraininghta_d1,xtraininghws_d1,xtraininghwd_d1,xtraininghpres_d1,xtraininghour)}
        if(configvar==4){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtraininghws,xtraininghwd,xtraininghpres,xtraininghta,xtraininghpblh,
                                              xtraininghpblh_d1,xtraininghta_d1,xtraininghws_d1,xtraininghwd_d1,xtraininghpres_d1,xtraininghour,
                                              xtrainingherrorm24)}
        if(configvar==5){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtraininghws,xtraininghwd,xtraininghpres,xtraininghta,xtraininghpblh,
                                              xtraininghpblh_d1,xtraininghta_d1,xtraininghws_d1,xtraininghwd_d1,xtraininghpres_d1,xtraininghour,
                                              xtrainingherrorm24,
                                              xtrainingherrorm1,xtrainingherrorm2,xtrainingherrorm3,xtrainingherrorm4,xtrainingherrorm5,xtrainingherrorm6)}
        if(configvar==6){ data0 <- data.frame(xtrainingtarget,xtraininghmod,xtraininghws,xtraininghwd,xtraininghpres,xtraininghta,xtraininghpblh,
                                              xtraininghpblh_d1,xtraininghta_d1,xtraininghws_d1,xtraininghwd_d1,xtraininghpres_d1,xtraininghour,
                                              xtrainingherrorm24,xtrainingherrorm48,
                                              xtraininghmodm24,xtraininghmodm48)}
        if(configvar==7){ data0 <- data.frame(xtrainingtarget,xtraininghmod,
                                              xtrainingherrorm24,xtrainingherrorm48,
                                              xtraininghmodm24,xtraininghmodm48)}
        dataTrainMultistations <- na.omit(data0)
    }                  
   
    print('********** Loop on configs - Get hopdata')
    hdata_all  <- array(NaN,dim=c(nconfigs,nvariables,nhtime))    
    hopdata_all <- array(NaN,dim=c(nconfigs,nforecast,nlengthforecast,nvariables+2))
    for (iconfig in 1:nconfigs){                
        print(paste(iconfig,configs[iconfig]))
        model_trained_flag=0
        
        for (i in 1:nforecast){
            #print(c(iconfig,i,nforecast))
            itime=(i-1)*timestep
            if(min(itime+1-timestep:1) >= 1 & max(itime+1-timestep:1) <= nhtime & (itime+nlengthforecast)<=nhtime){            
                hopdata_all[iconfig,i,,nvariables+1]=hobs[itime+1:nlengthforecast]
                hopdata_all[iconfig,i,,nvariables+2]=hmod[itime+1:nlengthforecast]

                ## (train ml model)
                if(model_trained_flag >= 0 & ((i >= imin & i%%ifreq==0) | i==nforecast)){
                    print(c('train...',i))
                    wtime=(24*2+1):(itime-4)
                                        #wtime=(24*2+1):((nforecast-1)*timestep)                    

                    if(configtarget==0){xtarget <-             hobs[wtime] ; print('TARGET : hobs')}
                    if(configtarget==1){xtarget <- hmod[wtime]-hobs[wtime] ; print('TARGET : hmod-hobs')}
                                                  
                    xhmod      <- hmod[wtime]                    
                    xherrorm24   <- hmod[wtime-24]-hobs[wtime-24]
                    xherrorm48   <- hmod[wtime-48]-hobs[wtime-48]
                    xhmodm24     <- hmod[wtime-24]
                    xhmodm48     <- hmod[wtime-48]                    
                    xherrorm1    <- hmod[wtime-1]-hobs[wtime-1]
                    xherrorm2    <- hmod[wtime-2]-hobs[wtime-2]
                    xherrorm3    <- hmod[wtime-3]-hobs[wtime-3]
                    xherrorm4    <- hmod[wtime-4]-hobs[wtime-4]
                    xherrorm5    <- hmod[wtime-5]-hobs[wtime-5]
                    xherrorm6    <- hmod[wtime-6]-hobs[wtime-6]
                    xhws        <- hws[wtime]
                    xhwd        <- hwd[wtime]
                    xhpres      <- hpres[wtime]
                    xhta        <- hta[wtime]
                    xhpblh      <- hpblh[wtime]
                    xrandom     <- runif(length(wtime),0,10)              
                    xhour       <- hour0to24(wtime%%24)
                    xhpblhm1      <- hpblh[wtime-1]
                    xhpblhp1      <- hpblh[wtime+1]
                    xhtam1        <- hta[wtime-1]
                    xhtap1        <- hta[wtime+1]                    
                    xhpblh_d1   <- hpblh[wtime]-hpblh[wtime-3]
                    xhta_d1     <- hta[wtime]-hta[wtime-3]
                    xhws_d1     <- hws[wtime]-hws[wtime-3]
                    xhwd_d1     <- hwd[wtime]-hwd[wtime-3]
                    xhpres_d1   <- hpres[wtime]-hpres[wtime-3]
                    xjulian     <- as.numeric(format(htime[wtime],"%j"))
                    
                    ## (choose features)
                    if(configvar==0){ data0 <- data.frame(xtarget,xhmod,xherrorm24)}
                    if(configvar==1){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh)}
                    if(configvar==11){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh,xhour)}
                    if(configvar==2){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                          xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1)}
                    if(configvar==3){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                          xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour)}
                    if(configvar==4){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                          xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                          xherrorm24)}
                    if(configvar==5){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                          xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                          xherrorm24,
                                                          xherrorm1,xherrorm2,xherrorm3,xherrorm4,xherrorm5,xherrorm6)}
                    if(configvar==6){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                          xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                          xherrorm24,xherrorm48,
                                                          xhmodm24,xhmodm48)}
                    if(configvar==7){ data0 <- data.frame(xtarget,xhmod,
                                                          xherrorm24,xherrorm48,
                                                          xhmodm24,xhmodm48)}                   
                    if(configvar==8){ data0 <- data.frame(xtarget,xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                          xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                          xherrorm24,xherrorm48,
                                                          xhmodm24,xhmodm48,xjulian)}
                                       
                    hxfeatures=htime[wtime]
                    hyfeatures=data0
                                        
                    features=colnames(data0)[2:length(colnames(data0))]                                          
                    nfeatures=length(features)

                    data <- na.omit(data0)
                    if(dim(data)[1]!=0){                        
                        #partition=0.95
                        #trainIndex <- createDataPartition(data$xtarget, p=partition, list=FALSE, times=1)                     
                        #dataTrain <- data[ trainIndex,]
                        #dataTest  <- data[-trainIndex,]
                        dataTrain=data

                        if(multistattraining==1){
                            dataTrain=dataTrainMultistations
                            colnames(dataTrain)=c('xtarget',features)
                        }
                        
                        print(dim(dataTrain))

                        if(substr(configs,1,3)=='knn'){                        
                            if(configtrain==1){
                                fitControl <- trainControl(method="repeatedcv", number=10, repeats=3, preProcOptions=c('center','scale'))                                                       
                                mlfit <- caret::train(xtarget~., data=dataTrain, method = "knn", trControl=fitControl, tuneLength=10)
                            }
                        }
                        if(substr(configs,1,2)=='lm'){                        
                            if(configtrain==1){
                                fitControl <- trainControl(method="repeatedcv", number=10, repeats=3, preProcOptions=c('center','scale'))                                                       
                                mlfit <- caret::train(xtarget~., data=dataTrain, method = "lm", trControl=fitControl)
                            }
                        }
                        if(substr(configs,1,3)=='gbm'){                        
                            if(configtrain==1){
                                fitControl <- trainControl(method="cv", number=10, preProcOptions=c('center','scale'))
                                mlfit <- caret::train(xtarget~., data=dataTrain, method="gbm", trControl=fitControl, verbose=FALSE)
                            }
                            if(configtrain==2){
                                fitControl <- trainControl(method="cv", number=10, preProcOptions=c('center','scale'))                            
                                tuneGrid   <- expand.grid(interaction.depth=1,
                                                          n.trees=150,
                                                          shrinkage=0.1,
                                                          n.minobsinnode=3)
                                bagfraction=as.numeric(tmp[7])
                                mlfit <- caret::train(xtarget~., data=dataTrain, method="gbm", trControl=fitControl, verbose=FALSE, tuneGrid=tuneGrid,bag.fraction=bagfraction)
                            }
                            if(configtrain==3){
                                fitControl <- trainControl(method="cv", number=10, preProcOptions=c('center','scale'))                            
                                tuneGrid   <- expand.grid(interaction.depth=3,
                                                          n.trees=1000,
                                                          shrinkage=0.2,
                                                          n.minobsinnode=5)
                                bagfraction=as.numeric(tmp[7])
                                mlfit <- caret::train(xtarget~., data=dataTrain, method="gbm", trControl=fitControl, verbose=FALSE, tuneGrid=tuneGrid,bag.fraction=bagfraction)
                            }
                            if(configtrain==4){
                                fitControl <- trainControl(method="cv", number=10, preProcOptions=c('center','scale'))                            
                                tuneGrid   <- expand.grid(interaction.depth=1:3,
                                                          n.trees=c(1000,2000),
                                                          shrinkage=0.2,
                                                          n.minobsinnode=3:5)
                                bagfraction=as.numeric(tmp[7])
                                mlfit <- caret::train(xtarget~., data=dataTrain, method="gbm", trControl=fitControl, verbose=FALSE, tuneGrid=tuneGrid,bag.fraction=bagfraction)
                            }                                
                        }
                        
                        #pdf('/esarchive/scratch/hpetetin/data/opmos/debug/debug.pdf',width=15,height=20,paper='a4r')
                        #pairs(data)
                        #dev.off()        
                        
                        if(substr(configs,1,3)=='gbm' | substr(configs,1,3)=='knn'){
                            if(exists("importance")==FALSE){importance <- array(NaN,dim=c(nfeatures,nforecast))}
                            x=varImp(mlfit)$importance
                            for (ifea in 1:nfeatures){
                                wfea=which(row.names(x)==features[ifea])
                                importance[ifea,i]=x[wfea,1]
                            }
                            importance_final=importance[,i]
                        }                        
                    }
                    model_trained_flag=1
                    print('train finished')                    
                }
                
                
                if(model_trained_flag==1){                                                         
                    for (ih in 1:nlengthforecast){
                        
                        xhmod       <- hmod[itime+ih]
                        
                        xherrorm24   <- hmod[itime+ih-24]-hobs[itime+ih-24]
                        xherrorm48   <- hmod[itime+ih-48]-hobs[itime+ih-48]
                        xhmodm24   <- hmod[itime+ih-24]
                        xhmodm48   <- hmod[itime+ih-48]  
                        xherrorm1    <- hmod[itime+ih-1]-hobs[itime+ih-1]
                        xherrorm2    <- hmod[itime+ih-2]-hobs[itime+ih-2]
                        xherrorm3    <- hmod[itime+ih-3]-hobs[itime+ih-3]
                        xherrorm4    <- hmod[itime+ih-4]-hobs[itime+ih-4]
                        xherrorm5    <- hmod[itime+ih-5]-hobs[itime+ih-5]
                        xherrorm6    <- hmod[itime+ih-6]-hobs[itime+ih-6]
                        xhws        <- hws[itime+ih]                       
                        xhwd        <- hwd[itime+ih]
                        xhpres      <- hpres[itime+ih]
                        xhta        <- hta[itime+ih]
                        xhpblh      <- hpblh[itime+ih]
                        xrandom     <- runif(1,0,10)                         
                        xhour       <- hour0to24(ih%%24)
                        xhpblhm1      <- hpblh[itime+ih-1]
                        xhpblhp1      <- hpblh[itime+ih+1]
                        xhtam1        <- hta[itime+ih-1]
                        xhtap1        <- hta[itime+ih+1]
                        xhpblh_d1     <- hpblh[itime+ih]-hpblh[itime+ih-3]
                        xhta_d1       <- hta[itime+ih]-hta[itime+ih-3]                    
                        xhws_d1       <- hws[itime+ih]-hws[itime+ih-3]
                        xhwd_d1       <- hwd[itime+ih]-hwd[itime+ih-3]
                        xhpres_d1     <- hpres[itime+ih]-hpres[itime+ih-3]
                        xjulian     <- as.numeric(format(htime[itime+ih],"%j"))

                        ## (choose features)                     
                        if(configvar==0){ data0 <- data.frame(xhmod,xherrorm24)}
                        if(configvar==1){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh)}
                        if(configvar==11){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh,xhour)}
                        if(configvar==2){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                              xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1)}
                        if(configvar==3){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                              xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour)}
                        if(configvar==4){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                              xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                              xherrorm24)}
                        if(configvar==5){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                              xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                              xherrorm24,
                                                              xherrorm1,xherrorm2,xherrorm3,xherrorm4,xherrorm5,xherrorm6)}
                        if(configvar==6){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                              xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                              xherrorm24,xherrorm48,
                                                              xhmodm24,xhmodm48)}
                        if(configvar==7){ data0 <- data.frame(xhmod,
                                                              xherrorm24,xherrorm48,
                                                              xhmodm24,xhmodm48)}       
                        if(configvar==8){ data0 <- data.frame(xhmod,xhws,xhwd,xhpres,xhta,xhpblh,
                                                              xhpblh_d1,xhta_d1,xhws_d1,xhwd_d1,xhpres_d1,xhour,
                                                              xherrorm24,xherrorm48,
                                                              xhmodm24,xhmodm48,xjulian)}


                        
                        data <- na.omit(data0)
                        if(nrow(data)!=0){                        
                            corr <- as.numeric(predict(mlfit,newdata=data))
                            
                            if(configtarget==0){                      
                                if(flag_negativeallowed==0){hopdata_all[iconfig,i,ih,1]=max(c(0,corr))}
                                if(flag_negativeallowed==1){hopdata_all[iconfig,i,ih,1]=corr}
                            }
                            if(configtarget==1){
                                if(flag_negativeallowed==0){hopdata_all[iconfig,i,ih,1]=max(c(0,hmod[itime+ih]-corr))}
                                if(flag_negativeallowed==1){hopdata_all[iconfig,i,ih,1]=hmod[itime+ih]-corr}
                            }
                        }
                    }                
                }        
            }
        }        
    }
       
    print('********** Homogeneize datasets')
    w=which(is.na(hopdata_all[,,,1])==TRUE | is.na(hopdata_all[,,,2])==TRUE | is.na(hopdata_all[,,,3])==TRUE)
    if(length(w)!=0){hopdata_all[w]=NaN}
    
    print('********** Get hdata')
    hdata_all <- array(NaN,dim=c(nconfigs,nvariables,nhtime,nversions))
    for (iconfig in 1:nconfigs){                
        for (ivar in 1:nvariables){
            for (i in 1:nforecast){
                for (k in 1:nversions){
                    if(i-k+1 > 0){                                                               
                        hdata_all[iconfig,ivar,(i-1)*timestep+1:timestep,k]=hopdata_all[iconfig,i-k+1,(k-1)*timestep+1:timestep,ivar]
                    }
                }
            }
        }
    }
 

    if(exists("importance")==TRUE){
        for (ifea in 1:nfeatures){
            importance_stat=array(NaN,dim=10)
            importance_stat[1]=meanok(importance[ifea,])
            importance_stat[2]=sdok(importance[ifea,])
            importance_stat[3]=quantileok(importance[ifea,],0.05)
            importance_stat[4]=quantileok(importance[ifea,],0.25)
            importance_stat[5]=quantileok(importance[ifea,],0.50)
            importance_stat[6]=quantileok(importance[ifea,],0.75)
            importance_stat[7]=quantileok(importance[ifea,],0.95)
            importance_stat[8]=minok(importance[ifea,])
            importance_stat[9]=maxok(importance[ifea,])
            
            print(paste(formatC(importance_stat[1],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[2],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[3],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[4],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[5],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[6],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[7],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[8],digits=2,width=10,format='f',flag=''),
                        formatC(importance_stat[9],digits=2,width=10,format='f',flag=''),features[ifea]))
        }
    }
}




###########################################################################
if(substr(what,1,3)=='kfs' | substr(what,1,3)=='kfd' | substr(what,1,2)=='an' | substr(what,1,2)=='ml'){
    hopdata <- array(NaN,dim=c(nforecast,nlengthforecast,nvariables+2))

    ibestconfig=NaN
    if(is.finite(maxok(hdata_all))){
        k=1
        
        print('********** Compute statistics for all configurations')
        hdata_stat <- array(NaN,dim=c(nconfigs,nmetrics))
        for (iconfig in 1:nconfigs){
            hdata_stat[iconfig,]=get_omstat(hobs,hdata_all[iconfig,1,,k])        
        }

        print('********** Find the optimal configuration')         
        optimetrics='RMSE' #(default choice)
        if(length(grep('RMSE',what))==1){optimetrics='RMSE'}
        if(length(grep('PCC' ,what))==1){optimetrics='PCC' }
        if(nconfigs==1){
            ibestconfig=1
        }else{        
            w=which(metrics==optimetrics)
            if(length(which(optimetrics==c('RMSE','FA','M','FAR','POFD')))==1 & is.finite(minok(hdata_stat[,w]))){
                ibestconfig <- which(hdata_stat[,w]==minok(hdata_stat[,w]))[1]        
            }
            if(length(which(optimetrics==c('PCC','H','CN','POD')))==1 & is.finite(maxok(hdata_stat[,w]))){
                ibestconfig <- which(hdata_stat[,w]==maxok(hdata_stat[,w]))[1]        
            }
        }
    }
    
    
    print('********** Get hourly data')
    if(is.na(ibestconfig)==FALSE){
        for (ivar in 1:nvariables){        
            for (k in 1:nversions){
                hdata[ivar,,k]=hdata_all[ibestconfig,ivar,,k]
            }        
        }

        for (i in 1:nforecast){
            for (ivar in 1:(nvariables+2)){                          
                for (ih in 1:nlengthforecast){
                    hopdata[i,ih,ivar]=hopdata_all[ibestconfig,i,ih,ivar]                     
                }
            }
        }
                                        #for (i in 1:nforecast){
                                        #    if(is.finite(max(hopdata[i,,]))==FALSE){hopdata[i,,]=NaN}
                                        #}
        
    }    
}


