ddata      <- array(NaN,dim=c(nvariables,ndtime,nversions))
mdata      <- array(NaN,dim=c(nvariables,nmtime,nversions))
h24data    <- array(NaN,dim=c(nvariables,24,nversions))
hxdata     <- array(NaN,dim=c(nvariables,ndtime,nversions))
dxdata     <- array(NaN,dim=c(nvariables,ndtime,nversions))
mxdata     <- array(NaN,dim=c(nvariables,nmtime,nversions))
h24xdata   <- array(NaN,dim=c(nvariables,24,nversions))
dmaxdata   <- array(NaN,dim=c(nvariables,ndtime,nversions))
dmaxxdata  <- array(NaN,dim=c(nvariables,ndtime,nversions))
dmda8data  <- array(NaN,dim=c(nvariables,ndtime,nversions))
dmda8xdata <- array(NaN,dim=c(nvariables,ndtime,nversions))

if(what!='obs' & what!='mod'){ 
    print('********** Get hopdata opstat')
    hfopdata <- array(NaN,dim=c(nlengthforecast,nvariables+2,10))
    w=1:ndtime
    for (ih in 1:nlengthforecast){
        for (ivar in 1:(nvariables+2)){
            hfopdata[ih,ivar,1]=meanok(hopdata[w,ih,ivar])
            hfopdata[ih,ivar,2]=sdok(hopdata[w,ih,ivar])
            hfopdata[ih,ivar,3]=quantileok(hopdata[w,ih,ivar],0.05)
            hfopdata[ih,ivar,4]=quantileok(hopdata[w,ih,ivar],0.25)
            hfopdata[ih,ivar,5]=quantileok(hopdata[w,ih,ivar],0.50)
            hfopdata[ih,ivar,6]=quantileok(hopdata[w,ih,ivar],0.75)
            hfopdata[ih,ivar,7]=quantileok(hopdata[w,ih,ivar],0.95)
            hfopdata[ih,ivar,8]=minok(hopdata[w,ih,ivar])
            hfopdata[ih,ivar,9]=maxok(hopdata[w,ih,ivar])
            hfopdata[ih,ivar,10]=length(which(is.finite(hopdata[w,ih,ivar])==TRUE))
        }
    }


    print('********** Get hopdata stat')
    hfopstat <- array(NaN,dim=c(nlengthforecast,2,nmetrics))
    hfoplimstat <- array(NaN,dim=c(nlengthforecast,2,nlimit,nmetricster))
    for (ih in 1:nlengthforecast){            
        hfopstat[ih,1,]=get_statistics(hopdata[,ih,nvariables+1],hopdata[,ih,nvariables+2])$res #(stat mod)
        hfopstat[ih,2,]=get_statistics(hopdata[,ih,nvariables+1],hopdata[,ih,1])$res            #(stat mos)        
        for (ilim in 1:nlimit){
            hfoplimstat[ih,1,ilim,]=get_statistics(hopdata[,ih,nvariables+1],hopdata[,ih,nvariables+2],lim1=limit[ilim],lim2=limit[ilim+1])$res #(stat mod)
            hfoplimstat[ih,2,ilim,]=get_statistics(hopdata[,ih,nvariables+1],hopdata[,ih,1],lim1=limit[ilim],lim2=limit[ilim+1])$res            #(stat mos)    
        }
    }       
    print(maxok(hfopstat))
}



print('********** Get daily data')
dobs <- ts_compute(htime,hobs,'daily')    
dmod <- ts_compute(htime,hmod,'daily')    
for (k in wversion){
    for (ivar in 1:nvariables){
        ddata[ivar,,k] <- ts_compute(htime,hdata[ivar,,k],'daily')    
    }
}


print('********** Get daily data for exact comparisons')    
hxobs=hobs
hxmod=hmod
hxdata=hdata

hdataobsmod   <- hobs+hmod
for (k in wversion){  
    for (ivar in 1:nvariables){
        hdataobsmod <- hdataobsmod+hdata[ivar,,k]
    }
}
w=which(is.na(hdataobsmod)==TRUE)     
if(length(w)!=0){
    hxobs[w]=NaN
    hxmod[w]=NaN
    for (k in wversion){  
        for (ivar in 1:nvariables){
            hxdata[ivar,w,k]=NaN
        }
    }  
}
dxobs <- ts_compute(htime,hxobs,'daily')    
dxmod <- ts_compute(htime,hxmod,'daily')    
for (k in wversion){
    for (ivar in 1:nvariables){
        dxdata[ivar,,k] <- ts_compute(htime,hxdata[ivar,,k],'daily')    
    }
}          




print('********** Get daily max data')
dmaxobs <- ts_compute(htime,hobs,'dailymax')    
dmaxmod <- ts_compute(htime,hmod,'dailymax')    
for (k in wversion){
    for (ivar in 1:nvariables){
        dmaxdata[ivar,,k] <- ts_compute(htime,hdata[ivar,,k],'dailymax')    
    }
}


print('********** Get daily max data for exact comparisons')
dmaxxobs <- ts_compute(htime,hxobs,'dailymax')    
dmaxxmod <- ts_compute(htime,hxmod,'dailymax')    
for (k in wversion){
    for (ivar in 1:nvariables){
        dmaxxdata[ivar,,k] <- ts_compute(htime,hxdata[ivar,,k],'dailymax')    
    }
}


print('********** Get daily max 8h data')
dmda8obs <- ts_compute(htime,hobs,'mda8')    
dmda8mod <- ts_compute(htime,hmod,'mda8')    
for (k in wversion){
    for (ivar in 1:nvariables){
        dmda8data[ivar,,k] <- ts_compute(htime,hdata[ivar,,k],'mda8')    
    }
}


print('********** Get daily max 8h data for exact comparisons')
dmda8xobs <- ts_compute(htime,hxobs,'mda8')    
dmda8xmod <- ts_compute(htime,hxmod,'mda8')    
for (k in wversion){
    for (ivar in 1:nvariables){
        dmda8xdata[ivar,,k] <- ts_compute(htime,hxdata[ivar,,k],'mda8')    
    }
}


print('********** Get monthly data')
mobs <- ts_compute(htime,hobs,'monthly')    
mmod <- ts_compute(htime,hmod,'monthly')    
for (k in wversion){
    for (ivar in 1:nvariables){
        mdata[ivar,,k] <- ts_compute(htime,hdata[ivar,,k],'monthly')    
    }
}


print('********** Get monthly data for exact comparisons')
mxobs <- ts_compute(htime,hxobs,'monthly')    
mxmod <- ts_compute(htime,hxmod,'monthly')    
for (k in wversion){
    for (ivar in 1:nvariables){
        mxdata[ivar,,k] <- ts_compute(htime,hxdata[ivar,,k],'monthly')    
    }
}


print('********** Get diurnal profiles data')
h24obs <- ts_compute(htime,hobs,'diurnal')    
h24mod <- ts_compute(htime,hmod,'diurnal')    
for (k in wversion){
    for (ivar in 1:nvariables){      
        h24data[ivar,,k] <- ts_compute(htime,hdata[ivar,,k],'diurnal')    
    }
}


print('********** Get diurnal profiles data for exact comparisons')
h24xobs <- ts_compute(htime,hxobs,'diurnal')    
h24xmod <- ts_compute(htime,hxmod,'diurnal')    
for (k in wversion){
    for (ivar in 1:nvariables){      
        h24xdata[ivar,,k] <- ts_compute(htime,hxdata[ivar,,k],'diurnal')    
    }
}


if(what!='obs' & what!='mod'){ 
    print('********** Get bin statistics function of forecast error')
    hvar <- hxmod-hxobs   
    binsize=10
    errorvarbin=seq(-100,100,binsize)
    nbin=length(errorvarbin)-1                     
    errorbinstat=array(NaN,dim=c(2,nbin,nmetrics,nversions))
    for (k in wversion){   
        for (ibin in 1:nbin){                
            w=which(hvar >= errorvarbin[ibin] & hvar < errorvarbin[ibin+1])
            if(length(w)>10){
                errorbinstat[1,ibin,,k]=get_statistics(hxobs[w],hxmod[w])$res
                errorbinstat[2,ibin,,k]=get_statistics(hxobs[w],hxdata[1,w,k])$res                             
            }                
        }
    }
    w=which(is.finite(errorbinstat)==FALSE) ; if(length(w)!=0){errorbinstat[w]=NaN}  


    print('********** Get bin statistics function of obseved concentration')
    hvar <- hxobs   
    binsize=10
    obsvarbin=seq(0,200,binsize)
    nbin=length(obsvarbin)-1                     
    obsbinstat=array(NaN,dim=c(2,nbin,nmetrics,nversions))
    for (k in wversion){   
        for (ibin in 1:nbin){                
            w=which(hvar >= obsvarbin[ibin] & hvar < obsvarbin[ibin+1])
            if(length(w)>10){
                obsbinstat[1,ibin,,k]=get_statistics(hxobs[w],hxmod[w])$res
                obsbinstat[2,ibin,,k]=get_statistics(hxobs[w],hxdata[1,w,k])$res                             
            }                
        }
    }
    w=which(is.finite(obsbinstat)==FALSE) ; if(length(w)!=0){obsbinstat[w]=NaN}  

}



if(substr(what,1,6)=='ml_gbm'){
    print('********** get partial dependency plots')
    resolution=30
    npdp=min(c(nfeatures,9))
    x=varImp(mlfit)$importance
    featurepdp <- array(NaN,dim=c(npdp,2,resolution))
    for (ivar in 1:npdp){
        tmp <- partial(mlfit,pred.var=row.names(x)[order(x,decreasing=TRUE)[ivar]],rug=TRUE,grid.resolution=resolution)
        featurepdp[ivar,1,] <- tmp[,1]
        featurepdp[ivar,2,] <- tmp[,2]
    }
}
