print('********** Write hourly data')
datatext='htime,obs,mod'
for (k in wversion){ datatext=paste0(datatext,',',paste0(variables,'_',k,collapse=',')) }
for (i in 1:nhtime){
    if(format(htime[i],'%H')=='00'){
        linetext=paste(paste(as.character(htime[i]),'00:00:00'),
                       formatC(hobs[i],digits=2,width=3,format='f',flag=''),
                       formatC(hmod[i],digits=2,width=3,format='f',flag=''),sep=',')
    }else{
        linetext=paste(as.character(htime[i]),
                       formatC(hobs[i],digits=2,width=3,format='f',flag=''),
                       formatC(hmod[i],digits=2,width=3,format='f',flag=''),sep=',')
    }            
    for (k in wversion){
        for (ivar in 1:nvariables){
            linetext=paste(linetext,formatC(hdata[ivar,i,k],digits=2,width=3,format='f',flag=''),sep=',')
        }
    }
    datatext=c(datatext,linetext)
}
file=paste(workdir,'/',outputfile,'_hdata.csv',sep='')
con <- file(file,open="w")
writeLines(datatext[1:length(datatext)], con = con)
close(con)
print(file)


print('********** Write daily data')
datatext='dtime,obs,mod'
for (k in wversion){ datatext=paste0(datatext,',',paste0(variables,'_',k,collapse=',')) }
for (i in 1:ndtime){    
    linetext=paste(as.character(dtime[i]),
                   formatC(dxobs[i],digits=2,width=3,format='f',flag=''),
                   formatC(dxmod[i],digits=2,width=3,format='f',flag=''),sep=',')
    for (k in wversion){
        for (ivar in 1:nvariables){
            linetext=paste(linetext,formatC(dxdata[ivar,i,k],digits=2,width=3,format='f',flag=''),sep=',')
        }
    }
    datatext=c(datatext,linetext)
}
file=paste(workdir,'/',outputfile,'_dxdata.csv',sep='')
con <- file(file,open="w")
writeLines(datatext[1:length(datatext)], con = con)
close(con)
print(file)


print('********** Write daily max data')
datatext='dtime,obs,mod'
for (k in wversion){ datatext=paste0(datatext,',',paste0(variables,'_',k,collapse=',')) }
for (i in 1:ndtime){    
    linetext=paste(as.character(dtime[i]),
                   formatC(dmaxxobs[i],digits=2,width=3,format='f',flag=''),
                   formatC(dmaxxmod[i],digits=2,width=3,format='f',flag=''),sep=',')
    for (k in wversion){
        for (ivar in 1:nvariables){
            linetext=paste(linetext,formatC(dmaxxdata[ivar,i,k],digits=2,width=3,format='f',flag=''),sep=',')
        }
    }
    datatext=c(datatext,linetext)
}
file=paste(workdir,'/',outputfile,'_dmaxxdata.csv',sep='')
con <- file(file,open="w")
writeLines(datatext[1:length(datatext)], con = con)
close(con)
print(file)


print('********** Write daily mda8 data')
datatext='dtime,obs,mod'
for (k in wversion){ datatext=paste0(datatext,',',paste0(variables,'_',k,collapse=',')) }
for (i in 1:ndtime){    
    linetext=paste(as.character(dtime[i]),
                   formatC(dmda8xobs[i],digits=2,width=3,format='f',flag=''),
                   formatC(dmda8xmod[i],digits=2,width=3,format='f',flag=''),sep=',')
    for (k in wversion){
        for (ivar in 1:nvariables){
            linetext=paste(linetext,formatC(dmda8xdata[ivar,i,k],digits=2,width=3,format='f',flag=''),sep=',')
        }
    }
    datatext=c(datatext,linetext)
}
file=paste(workdir,'/',outputfile,'_dmda8xdata.csv',sep='')
con <- file(file,open="w")
writeLines(datatext[1:length(datatext)], con = con)
close(con)
print(file)


print('********** Write monthly data')
datatext='mtime,obs,mod'
for (k in wversion){ datatext=paste0(datatext,',',paste0(variables,'_',k,collapse=',')) }
for (i in 1:nmtime){    
    linetext=paste(as.character(format(mtime[i],"%Y-%m")),
                   formatC(mxobs[i],digits=2,width=3,format='f',flag=''),
                   formatC(mxmod[i],digits=2,width=3,format='f',flag=''),sep=',')
    for (k in wversion){
        for (ivar in 1:nvariables){
            linetext=paste(linetext,formatC(mxdata[ivar,i,k],digits=2,width=3,format='f',flag=''),sep=',')
        }
    }
    datatext=c(datatext,linetext)
}
file=paste(workdir,'/',outputfile,'_mxdata.csv',sep='')
con <- file(file,open="w")
writeLines(datatext[1:length(datatext)], con = con)
close(con)
print(file)


print('********** Write diurnal profiles data')
datatext='hour,obs,mod'
for (k in wversion){ datatext=paste0(datatext,',',paste0(variables,'_',k,collapse=',')) }
for (i in 1:24){
    linetext=paste(i,
                   formatC(h24xobs[i],digits=2,width=3,format='f',flag=''),
                   formatC(h24xmod[i],digits=2,width=3,format='f',flag=''),sep=',')
    for (k in wversion){
        for (ivar in 1:nvariables){
            linetext=paste(linetext,formatC(h24xdata[ivar,i,k],digits=2,width=3,format='f',flag=''),sep=',')
        }
    }
    datatext=c(datatext,linetext)
}
file=paste(workdir,'/',outputfile,'_h24xdata.csv',sep='')
con <- file(file,open="w")
writeLines(datatext[1:length(datatext)], con = con)
close(con)
print(file)



if(what!='obs' & what!='mod'){ 
    
    print('********** Write statistics - from hourly/daily/monthly data')    
    for (i in c('hx','dx','mx','dmaxx','mda8x')){
        if(i=='hx'   ){xobs=hxobs     ; xmod=hxmod     ; xdata=hxdata}
        if(i=='dx'   ){xobs=dxobs     ; xmod=dxmod     ; xdata=dxdata}
        if(i=='mx'   ){xobs=mxobs     ; xmod=mxmod     ; xdata=mxdata}
        if(i=='dmaxx'){xobs=dmaxxobs  ; xmod=dmaxxmod  ; xdata=dmaxxdata}
        if(i=='mda8x'){xobs=dmda8xobs ; xmod=dmda8xmod ; xdata=dmda8xdata}

        header='configuration : none'
        if(substr(what,1,3)=='kfs' |
           substr(what,1,3)=='kfd'){header=paste0('configuration : ',configs[ibestconfig])}    
        datatext=c(header,
                   get_statistics(mode='legend',width=8,sep=',')$cleg,
                   get_statistics(xobs,xmod,8,2,sep=',')$cres)              
        for (k in wversion){
            datatext=c(datatext,get_statistics(xobs,xdata[1,,k],8,2,sep=',')$cres)
        }    
        file=paste(workdir,'/',outputfile,'_',i,'stat.csv',sep='')
        con <- file(file,open="w")
        writeLines(datatext[1:length(datatext)], con = con)
        close(con)
        print(file)
    }


    if(1==1){
        print('********** Write statistics - from hourly/daily/dailymax data with with limits')    
        for (k in wversion){
            for (i in c('hx','dx','dmaxx','dmda8x')){
                if(i=='hx'    ){xobs=hxobs     ; xmod=hxmod     ; xdata=hxdata}
                if(i=='dx'    ){xobs=dxobs     ; xmod=dxmod     ; xdata=dxdata}
                if(i=='dmaxx' ){xobs=dmaxxobs  ; xmod=dmaxxmod  ; xdata=dmaxxdata}
                if(i=='dmda8x'){xobs=dmda8xobs ; xmod=dmda8xmod ; xdata=dmda8xdata}    
                datatext=get_statistics(mode='legendter',width=7,sep=',')$cleg
                for (ilim in 1:nlimit){
                    datatext=c(datatext,
                               get_statistics(xobs,xmod,7,1,lim1=limit[ilim],lim2=limit[ilim+1],sep=',')$cres,
                               get_statistics(xobs,xdata[1,,k],7,1,lim1=limit[ilim],lim2=limit[ilim+1],sep=',')$cres)
                                        #print('*******')
                                        #print(get_statistics(xobs,xmod,7,1,lim1=limit[ilim],lim2=limit[ilim+1],sep=',')$cres)
                                        #print(get_statistics(xobs,xdata[1,,k],7,1,lim1=limit[ilim],lim2=limit[ilim+1],sep=',')$cres)
                }
                con <- file(paste(workdir,'/',outputfile,'_',i,k,'limstat.csv',sep=''),open="w")
                writeLines(datatext[1:length(datatext)], con = con)
                close(con)
            }
        }
    }
    

    print('********** Write error bin statistics')
    for (k in wversion){
        datatext=paste('  lim1,  lim2',get_statistics(mode='legend',width=7,sep=',')$cleg,sep=',')
        for (ibin in 1:nbin){
            for (j in 1:2){
                linetext=paste0(formatC(errorvarbin[ibin],digits=0,width=6,format='f',flag=''),',',
                               formatC(errorvarbin[ibin+1],digits=0,width=6,format='f',flag=''),',')
                for (im in 1:nmetrics){
                    linetext=paste0(linetext,
                                   formatC(errorbinstat[j,ibin,im,k],digits=2,width=7,format='f',flag=''),sep=',')
                }
                datatext=c(datatext,linetext)
            }
        }
        con <- file(paste(workdir,'/',outputfile,'_hx',k,'errorbinstat.csv',sep=''),open="w")
        writeLines(datatext[1:length(datatext)], con = con)
        close(con)
    }


    print('********** Write obs bin statistics')
    for (k in wversion){
        datatext=paste('  lim1,  lim2',get_statistics(mode='legend',width=8,sep=',')$cleg,sep=',')
        for (ibin in 1:nbin){
            for (j in 1:2){
                linetext=paste(formatC(obsvarbin[ibin],digits=0,width=6,format='f',flag=''),
                               formatC(obsvarbin[ibin+1],digits=0,width=6,format='f',flag=''),sep=',')
                for (im in 1:nmetrics){
                    linetext=paste(linetext,
                                   formatC(obsbinstat[j,ibin,im,k],digits=2,width=7,format='f',flag=''),sep=',')
                }
                datatext=c(datatext,linetext)
            }
        }
        con <- file(paste(workdir,'/',outputfile,'_hx',k,'obsbinstat.csv',sep=''),open="w")
        writeLines(datatext[1:length(datatext)], con = con)
        close(con)
    }



    print('********** Write hfopdata')
    datatext='ivar,hour,mean,sd,p05,p25,p50,p75,p95,min,max,N'
    for (ivar in 1:(nvariables+2)){
        for (ih in 1:nlengthforecast){
            linetext=paste0(ivar,ih,sep=',')       
            for (im in 1:10){     
                linetext=paste(
                    linetext,
                    formatC(hfopdata[ih,ivar,im],digits=2,width=7,format='f',flag=''),sep=',')
            }
            datatext=c(datatext,linetext)
        }
    }
    con <- file(paste(workdir,'/',outputfile,'_hfopdata.csv',sep=''),open="w")
    writeLines(datatext[1:length(datatext)], con = con)
    close(con)



    print('********** Write hfopstat')
    datatext=paste('mod1mos2,hour',get_statistics(mode='legend',width=8,sep=',')$cleg,sep=',')
    for (i in 1:2){
        for (ih in 1:nlengthforecast){
            linetext=paste0(formatC(i,digits=0,width=8,format='f',flag=''),',',
                            formatC(ih,digits=0,width=4,format='f',flag=''))       
            for (im in 1:nmetrics){     
                linetext=paste(
                    linetext,
                    formatC(hfopstat[ih,i,im],digits=2,width=7,format='f',flag=''),sep=',')
            }
            datatext=c(datatext,linetext)
        }
    }
    con <- file(paste(workdir,'/',outputfile,'_hfopstat.csv',sep=''),open="w")
    writeLines(datatext[1:length(datatext)], con = con)
    close(con)


    
    if(exists("importance_final")==TRUE){
        print('********** Write feature importance')
        datatext='feature,importance'
        for (ifea in 1:nfeatures){     
            datatext=c(datatext,paste(features[ifea],formatC(importance_final[ifea],digits=2,width=0,format='f',flag=''),sep=','))       
        }
        con <- file(paste(workdir,'/',outputfile,'_importance.csv',sep=''),open="w")
        writeLines(datatext[1:length(datatext)], con = con)
        close(con)
    }
}


print('********** Save hopdata (only concentration)')
for (i in 1:nforecast){
    itime=(i-1)*timestep+1
    if(i==1){
        save_time=htime[itime]
    }else{
        save_time=c(save_time,htime[itime])
    }
} 
save_hopdata         <- as.data.frame(hopdata[,,1])
save_hopdata$time    <- save_time
save_hopdata$station <- rep(station,nforecast)
colnames(save_hopdata) <- c(paste0(1:nlengthforecast,"h"),'htime','station')   
save(save_hopdata,file=paste0(workdir,'/',outputfile,'_hopdata.Rdata'))
print(dim(save_hopdata))
print(object.size(save_hopdata))


print('********** Save hdata')
ivar=1
for (k in wversion){
    
    save_hdata         <- as.data.frame(rep(station,nhtime))
    save_hdata$htime   <- htime
    save_hdata$hobs    <- hobs   
    save_hdata$hmod    <- hmod
    save_hdata$hmos    <- hdata[ivar,,k]
    colnames(save_hdata) <- c('station','htime','hobs','hmod','hmos')   
    save(save_hdata,file=paste0(workdir,'/',outputfile,'_',k,'_hdata.Rdata'))
    print(dim(save_hdata))
    print(object.size(save_hdata))
}
