print('********** Plot')
figout=paste0(workdir,'/',outputfile,'_',k,'.pdf',sep='')
pdf(figout,width=15,height=20,paper='a4r')


print('********** Preliminaries for plot')
cex=1.8
lwd=3
ptcex=2   
par(xaxs='i',yaxs='i',cex=cex,cex.axis=cex,cex.lab=cex,cex.main=cex)
main=''
if(substr(what,1,3)=='kfs'){ main=paste0('STATIC : w_over_v=',configs[ibestconfig],' / v_t=',v_t)}
if(substr(what,1,3)=='kfd'){ main=paste0('DYNAMIC : ndynwindow=',configs[ibestconfig]) }        




## plot 1 - obs/mod/<what> time series - concentrations 
print('********** plot 1')       
par(mar=c(5,5,2,2),mfrow=c(2,1))
for (i in 1:6){
    if(i==1){t=htime ; o=hobs  ; m=hmod  ; d=hdata[1,,k]  ; mainsuffix='(non exact)'} 
    if(i==2){t=htime ; o=hxobs ; m=hxmod ; d=hxdata[1,,k] ; mainsuffix=''}
    if(i==3){t=dtime ; o=dobs  ; m=dmod  ; d=ddata[1,,k]  ; mainsuffix='(non exact)'} 
    if(i==4){t=dtime ; o=dxobs ; m=dxmod ; d=dxdata[1,,k] ; mainsuffix=''}
    if(i==5){t=mtime ; o=mobs  ; m=mmod  ; d=mdata[1,,k]  ; mainsuffix='(non exact)'} 
    if(i==6){t=mtime ; o=mxobs ; m=mxmod ; d=mxdata[1,,k] ; mainsuffix=''}
    #print(paste(i,meanok(o),meanok(m),meanok(d)))
    
    ylim=c(0,1.6*maxok(c(o,m,d)))

    if(i <= 2){www=which(htime>=dtime[220])}else{www=1:length(t)} ;  www=1:length(t)  ## testherve
    
    plot(t[www],o[www],type='n',ylim=ylim,xlab='Date',ylab=legvariables[1],main=paste(main,mainsuffix))
    grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
    points(t,o,type='l',lwd=lwd,col=colo)
    points(t,m,type='l',lwd=lwd,col=colm)
    points(t,d,type='l',lwd=lwd,col=cold)
    if(i >= 5){
        points(t,o,type='p',pch=pcho,col=colo,cex=ptcex)
        points(t,m,type='p',pch=pchm,col=colm,cex=ptcex)
        points(t,d,type='p',pch=pchd,col=cold,cex=ptcex)
        legend('topleft',legomd,lty=1,lwd=lwd,col=colomd,pch=pchomd,bg='white',cex=cex*0.8,pt.cex=ptcex)
    }else{    
        legend('topleft',legomd,lty=1,lwd=lwd,col=colomd,pch=-1,bg='white',cex=cex*0.8)
    }
}
main=''


## plot 2 - <what> time series - other variables
if(nvariables>1){
    print('********** plot 2')       
    par(mar=c(5,5,2,2),mfrow=c(3,1))
    for (ivar in 2:nvariables){
        for (i in 1:3){
            if(i==1){t=htime ; d=hdata[ivar,,k]}
            if(i==2){t=dtime ; d=ddata[ivar,,k]}
            if(i==3){t=mtime ; d=mdata[ivar,,k]}
            ylim=rangeok(d,0.1,0.5)
            plot(t,d,type='n',ylim=ylim,xlab='Date',ylab=legvariables[ivar],main=main)
            grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
            points(t,d,type='l',lwd=lwd,col=cold)  
            if(i==3){
                points(t,d,type='p',pch=pchd,col=cold,cex=ptcex)  
                legend('top',what,lty=1,lwd=lwd,col=cold,pch=pchd,bg='white',cex=cex,pt.cex=cex)       
            }else{
                legend('top',what,lty=1,lwd=lwd,col=cold,pch=-1,bg='white',cex=cex,pt.cex=cex)       
            }
        }
    }
}







## plot 3 - obs/mod/<what> time series - diurnal 
print('********** plot 3')       
par(mar=c(5,5,2,2),mfrow=c(2,2))
for (i in 1:2){
    t=1:24
    if(i==1){o=h24obs  ; m=h24mod  ; d=h24data[1,,k]  ; mainsuffix='(non exact)'} 
    if(i==2){o=h24xobs ; m=h24xmod ; d=h24xdata[1,,k] ; mainsuffix=''}  
    ylim=rangeok(c(o,m,d),0.1,0.8)
    plot(t,o,type='n',ylim=ylim,xlab='Hour of the day',ylab=legvariables[1],main=paste(main,mainsuffix))
    grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
    points(t,o,type='l',lwd=lwd,col=colo)
    points(t,m,type='l',lwd=lwd,col=colm)
    points(t,d,type='l',lwd=lwd,col=cold)
    points(t,o,type='p',pch=pcho,col=colo,cex=ptcex)
    points(t,m,type='p',pch=pchm,col=colm,cex=ptcex)
    points(t,d,type='p',pch=pchd,col=cold,cex=ptcex)
    legend('topleft',legomd,lty=1,lwd=lwd,col=colomd,pch=pchomd,bg='white',cex=cex,pt.cex=ptcex)
}


## plot 4 - <what> other variables diurnal
if(nvariables>1){
    print('********** plot 4')       
    par(mar=c(5,5,2,2),mfrow=c(2,2))
    for (ivar in 1:nvariables){
        t=1:24 ; d=h24data[ivar,,k]
        ylim=rangeok(d,0.1,0.8)
        if(all(is.finite(ylim))){
            plot(t,d,type='n',ylim=ylim,xlab='Hour of the day',ylab=legvariables[ivar],main=main)
            grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
            points(t,d,type='l',lwd=lwd,col=cold)      
            points(t,d,type='p',pch=pchd,col=cold,cex=ptcex)
            legend('topleft',what,lty=1,lwd=lwd,col=cold,pch=pchd,bg='white',cex=cex,pt.cex=cex)       
        }else{
            plotblank()
        }        
    }
}

## plot 5 - scatter plots
print('********** plot 5')
par(mar=c(5,5,2,2),mfrow=c(2,2))

imax=2
if(substr(what,1,2)=='an'){imax=4}
if(what=='mod'){imax=1}
for (i in 1:imax){
    if(i==1){x=hobs      ; y=hmod      ; col=colm ; xlab='Observations' ; ylab='mod'} 
    if(i==2){x=hobs      ; y=hdata[1,,k] ; col=cold ; xlab='Observations' ; ylab=what}
    if(i==3){x=hdata[1,,k] ; y=hdata[3,,k] ; col=cold ; xlab=legvariables[1] ; ylab=legvariables[3]}
    if(i==4){x=hdata[2,,k] ; y=hdata[4,,k] ; col=cold ; xlab=legvariables[1] ; ylab=legvariables[3]}    
    main=''
    lm=lm(y~x)
    a=summary(lm)$coefficients[2]
    b=summary(lm)$coefficients[1]
    r=corok(x,y)
    main=paste0('y=',formatC(a,digits=2,width=3,format='f',flag=''),'x+',                       
                formatC(b,digits=2,width=3,format='f',flag=''),' (r=',
                formatC(r,digits=2,width=3,format='f',flag=''),')')    
    lim=rangeok(c(hobs,hmod,hdata[1,,k]),0.02,0.02)
    plot(x,y,type='p',pch=16,col=adjustcolor(col,alpha.f=0.3),xlab='Observations',ylab=paste('Model',ylab),main=main,xlim=lim,ylim=lim)   
    points(c(-1,1)*1e9,c(-1,1)*1e9,type='l',lty=2)
    if(length(w)!=0){abline(lm,col='black',lwd=lwd)}   
}




if(substr(what,1,3)=='kfs' | substr(what,1,3)=='kfd'){
    ## plot 6 - optimal configuration
    print('********** plot 6')
    par(mar=c(5,5,2,2),mfrow=c(2,2))
    if(substr(what,1,3)=='kfs'){xlab='W/V' ; log='x'}
    if(substr(what,1,3)=='kfd'){xlab='Nwindow' ; log=''}    
    wm=which(metrics==optimetrics)
    for (im in unique(c(which(metrics==optimetrics),1,3,5))){        
        plot(configs,hdata_stat[,im],type='n',xlab=xlab,ylab=metrics[im],log=log,
             main=paste0(xlab,'{',optimetrics,'} = ',configs[ibestconfig]))
        grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)        
        points(configs[ibestconfig]*c(1,1),c(-1,1)*1e9,type='l',lwd=lwd,col=cold)
        points(configs,hdata_stat[,im],type='p',pch=16)
        points(configs,hdata_stat[,im],type='l',lwd=lwd)        
        points(configs[ibestconfig],hdata_stat[ibestconfig,im],type='p',pch=16,cex=ptcex,col=cold)
    }
}










## plot 7 - error versus bias/concentration
if(what!='mod'){
    print('********** plot 7')
    par(mar=c(4,5,1,1),mfrow=c(2,3))        
    for (i in 1:2){    
        for (im in c(1,3,7,2,4,15)){
            if(i==1){ varbin=errorvarbin ; binstat=errorbinstat[,,im,k] ; xlab='Forecast error'}
            if(i==2){ varbin=obsvarbin   ; binstat=obsbinstat[,,im,k]   ; xlab='Observed concentration'}        
            
            w=which(is.finite(binstat[1,])==TRUE & is.finite(binstat[2,])==TRUE)
            if(length(w)>1){
                varbin=varbin[w] ; binstat=binstat[,w] ; nbin=length(varbin)            
                xlim=rangeok(c(varbin,max(varbin+binsize)))
                
                if(metrics[im]=='RMSE' | metrics[im]=='NRMSE' | metrics[im]=='N'){
                    ylim=rangeok(binstat,0,0.4,zero=TRUE)
                }else{
                    ylim=rangeok(binstat,0.1,0.4)
                }
                if(all(is.finite(ylim))==TRUE){
                    plot(varbin+binsize/2,binstat[1,],type='n',xlab=xlab,ylab=metrics[im],xlim=xlim,ylim=ylim)
                    grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
                    if(metrics[im]=='MB'){points(c(-1,1)*1e9,c(0,0),type='l',lwd=2)}
                    points(varbin+binsize/2,binstat[1,],type='l',lwd=lwd,col=colm)
                    points(varbin+binsize/2,binstat[2,],type='l',lwd=lwd,col=cold)
                    points(varbin+binsize/2,binstat[1,],type='p',pch=pchm,col=colm,cex=ptcex)
                    points(varbin+binsize/2,binstat[2,],type='p',pch=pchd,col=cold,cex=ptcex)                
                    legend('topleft',legmd,lty=1,lwd=lwd,col=colmd,pch=pchmd,bg='white',cex=cex*0.8,pt.cex=ptcex)   
                }else{
                    plotblank()
                }
            }
        }    
    }



    print('********** Plot 8')        
    par(mar=c(4.5,4.5,1.5,1),mfrow=c(3,2))
    hforecast=1:nlengthforecast
#    for (ivar in which(legvariables=='Concentration' | legvariables=='Error')){
    for (ivar in which(legvariables=='Concentration')){
        if(legvariables[ivar]=='Concentration'){
            ylim=rangeok(hfopdata[,c(ivar,nvariables+1:2),1],0.1,1)
            main=paste(legneg,'mode')
        }else{
            ylim=rangeok(hfopdata[,ivar,1],0.1,1)
            if(ivar==3){
                x=1:nlengthforecast/24
                y=hfopdata[,3,1] 
                trendmb=summary(lm(y~x))$coefficients[2]
                main=paste(formatC(trendmb,digits=2,width=2,format="f",flag=" "),'ug/m3/day')
            }else{
                main=''
            }
        }
        plot(hforecast,hfopdata[,1,1],type='n',ylim=ylim,xlab='Forecast hour',ylab=legvariables[ivar],main=main)
        grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
        points(c(-1,1)*1e9,c(0,0),type='l',lwd=2)    
        points(hforecast,hfopdata[,ivar,1],type='p',lwd=lwd,col=cold,pch=pchd,cex=cex)
        points(hforecast,hfopdata[,ivar,1],type='l',lwd=lwd,col=cold)
        if(legvariables[ivar]=='Concentration'){
            points(hforecast,hfopdata[,nvariables+1,1],type='p',col=colo,pch=pcho,cex=cex)
            points(hforecast,hfopdata[,nvariables+1,1],type='l',col=colo,lwd=lwd)
            points(hforecast,hfopdata[,nvariables+2,1],type='p',col=colm,pch=pchm,cex=cex)
            points(hforecast,hfopdata[,nvariables+2,1],type='l',col=colm,lwd=lwd)
            legend('topleft',legomd,lty=1,lwd=lwd,col=colomd,pch=pchomd,bg='white',cex=cex*0.8,pt.cex=ptcex)
        }else{
           # fillplot(1:nforecast,hfopdata[,ivar,1],cold,0.5)               
            legend('topleft',what,lty=1,lwd=lwd,col=cold,pch=pchd,bg='white',cex=cex,pt.cex=cex)
        }        
    }


    for (im in c(1,3,5,6,7,2,4)){
        x=1:nlengthforecast/24
        y=hfopstat[,2,im]
        trendmb=summary(lm(y~x))$coefficients[2]      
        ylim=rangeok(hfopstat[,,im],0.1,1)                                                                        
        plot(hforecast,hfopstat[,1,im],type='n',ylim=ylim,xlab='Forecast hour',ylab=metrics[im])
        grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
        points(c(-1,1)*1e9,c(0,0),type='l',lwd=2)          
        points(hforecast,hfopstat[,1,im],type='p',lwd=lwd,col=colm,pch=pchm,cex=cex)
        points(hforecast,hfopstat[,1,im],type='l',lwd=lwd,col=colm)
        points(hforecast,hfopstat[,2,im],type='p',lwd=lwd,col=cold,pch=pchd,cex=cex)
        points(hforecast,hfopstat[,2,im],type='l',lwd=lwd,col=cold)
        legend('topleft',legmd,lty=1,lwd=lwd,col=colmd,pch=pchmd,bg='white',cex=cex,pt.cex=cex)

        mod_mean <- meanok(hfopstat[,1,im])
        mos_mean <- meanok(hfopstat[,2,im])
        x=1:nlengthforecast/24 ; y=hfopstat[,1,im]
        mod_trend <- summary(lm(y~x))$coefficients[2]
        mod_trendsd <- summary(lm(y~x))$coefficients[4]
        x=1:nlengthforecast/24 ; y=hfopstat[,2,im]
        mos_trend <- summary(lm(y~x))$coefficients[2]
        
        text(min(hforecast),max(ylim)+(max(ylim)-min(ylim))*0.05,
             paste0(formatC(mod_mean,digits=1,width=2,format="f",flag=""),'/',
                    formatC(mod_trend,digits=3,width=2,format="f",flag="")),xpd=TRUE,cex=cex,adj=0,col=colm)
        text(max(hforecast),max(ylim)+(max(ylim)-min(ylim))*0.05,
             paste0(formatC(mos_mean,digits=1,width=2,format="f",flag=""),'/',
                    formatC(mos_trend,digits=3,width=2,format="f",flag="")),xpd=TRUE,cex=cex,adj=1,col=cold)                       
    }


}






if(exists("hxfeatures")==TRUE){
  
    print('********** plot features')       
    for (ifea in 1:nfeatures){
        par(mar=c(5,5,2,2),mfrow=c(2,1))
        wfea=which(colnames(hyfeatures)==features[ifea])
        plot(hxfeatures,hyfeatures[,wfea],type='n',xlab='Date',ylab=features[ifea])
        grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
        points(hxfeatures,hyfeatures[,wfea],type='l',pch=pchd,col=cold,cex=ptcex)  
        
        dyfeatures=ts_compute(hxfeatures,hyfeatures[,wfea],'daily')
        dxfeatures=as.Date(unique(format(htime[wtime],format='%Y-%m-%d')))
        
        plot(dxfeatures,dyfeatures,type='n',xlab='Date',ylab=features[ifea])
        grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
        points(dxfeatures,dyfeatures,type='l',pch=pchd,col=cold,cex=ptcex)         
    }    

    if(substr(what,1,6)=='ml_gbm'){
        print('********** plot partial dependency plots')
        x=varImp(mlfit)$importance
        for (kplot in 1:2){
            par(mar=c(5,5,2,2),mfrow=c(3,3))
            if(kplot==1){ ylim=rangeok(featurepdp[,2,]) }
            if(kplot==2){ ylim=rangeok(featurepdp[2:npdp,2,]) }
            for (ivar in 1:npdp){
                variable=row.names(x)[order(x,decreasing=TRUE)[ivar]]        
                plot(featurepdp[ivar,1,],featurepdp[ivar,2,],type='n',pch=16,col=cold,cex=cex,
                     ylim=ylim,xlab=variable,ylab='Partial dependence')
                fillplot(featurepdp[ivar,1,],featurepdp[ivar,2,],cold,1)
                for (idec in (0:10)/10){            
                    points(quantileok(hyfeatures[,which(colnames(hyfeatures)==variable)],idec),min(ylim),type='p',pch="|",cex=2)
                }
                grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
            }
        }
    }
}


if(exists("importance_final")==TRUE){
    print('********** Plot 9')        
    par(mar=c(5,15,3,3),mfrow=c(1,1))      
    plot(c(-5,105),c(0.5,nfeatures+0.5),type='n',xlab='Feature importance',ylab='',axes=FALSE)
    grid(nx=NULL,ny=NULL,col='grey',lwd=0.7,lty=1)
    for (ifea in 1:nfeatures){
        points(c(0,importance_final[ifea]),ifea*c(1,1),type='l',lwd=20)
        points(c(0,importance_final[ifea]),ifea*c(1,1),type='l',lwd=16,col=cold)
    }

    itrain=1
    for (i in 1:nforecast){
        if(is.finite(importance[1,i])==TRUE){
            for (ifea in 1:nfeatures){
                #points(importance[ifea,i],ifea,type='p',pch=16,cex=3)
                #text(importance[ifea,i],ifea,itrain,adj=0.5,cex=1,col=cold,font=2)
                text(importance[ifea,i],ifea,itrain,adj=0.5,cex=1,font=2)
 
            }
            itrain=itrain+1
        }
    }

    
    axis(1,at=c(-1e9,axTicks(1),1e9),
         labels=formatC(c(-1e9,axTicks(1),1e9),digits=0,width=2,format="f",flag=" "),
         las=1,cex=cex,cex.axis=cex)
    axis(2,at=c(-1e9,1:nfeatures,1e9),labels=c('',substr(features,2,99),''),las=1,cex=cex,cex.axis=cex)    
    axis(3,at=c(-1e9,1e9))
    axis(4,at=c(-1e9,1e9))
}


print(figout)
dev.off()        
