### source('~/scripts/opmos/select_stations.R')

print('**************************************************************************************************** ')
if(1==1){
    args = commandArgs(TRUE)
    print(args)
    pollutant             <- args[1]
    d1                    <- args[2]
    d2                    <- args[3] 
    infile                <- args[4] 
    outfile               <- args[5] 
    criteria              <- args[6] 
    experiment            <- args[7]
    indir                 <- args[8]
    station               <- args[9]

print(args)

}else{
    pollutant             <- "PM10"   
    d1                    <- "2015010100" 
    d2                    <- "2015093023"  
    infile                <- "/home/bsc32/bsc32883/scripts/opmos/tmp_filestations_all"
    outfile               <- "/home/bsc32/bsc32883/scripts/opmos/tmp_filestations"
    criteria              <- 75
    experiment            <- 'b007'
    indir                 <- '/gpfs/scratch/bsc32/bsc32883/data/extractions_et'
    station               <-'IP-RUR'
}

print(paste('**************************************************>> ',pollutant))

date1=ISOdate(substr(d1,1,4),substr(d1,5,6),substr(d1,7,8),substr(d1,9,10),tz='UTC')
date2=ISOdate(substr(d2,1,4),substr(d2,5,6),substr(d2,7,8),substr(d2,9,10),tz='UTC')
htime <- seq(date1,date2,"hours")  ; nhtime <- length(htime)

#if(experiment=='b0a6'  ){file=paste0('/esarchive/scratch/hpetetin/data/extractions_et/b0a6/data/ALL_b0a6_',pollutant,'_EIONET_spain_HL_20150101_20151231.RData')}
#if(experiment=='b007'  ){file=paste0('/esarchive/scratch/hpetetin/data/extractions_et/b007/data/ALL_b007_',pollutant,'_EIONET_spain_HL_20150101_20151231.RData')}
#if(experiment=='cams50'){file=paste0('/esarchive/scratch/hpetetin/data/extractions_et/cams50/data/ALL_cams50_',pollutant,'_EIONET_nrt_spain_HL_20151001_20181031.RData')}


setid='spain'
if(station=='RUR'){setid='rural'}
if(station=='URB'){setid='urban'}
if(station=='SUB'){setid='suburban'}


if(experiment=='b0a6' | experiment=='b007'){datesuffix='20150101_20151231' ; network='EIONET'}
if(experiment=='cams50'                   ){datesuffix='20160101_20171231' ; network='EIONET_nrt'}
print(pollutant)
file=paste0(indir,'/',experiment,'/data/ALL_',experiment,'_',pollutant,'_',network,'_',setid,'_HL_',datesuffix,'.RData')
print(file)
print(outfile)

load(file)

tab=as.vector(read.table(infile,colClasses='character')[,1])
text=''
for (istat in 1:length(tab)){
    wstat=which(data.all$station==tab[istat])
    
    tmp=data.all[wstat,]
    tmptime=as.POSIXct(tmp[,2],format="%Y-%m-%d %H:%M:%S")
    
    w=which(tmptime >= date1 & tmptime <= date2 & is.na(tmp$obs)==FALSE)
    ndata=100*length(w)/nhtime
    if(ndata >= criteria){
        text=c(text,tab[istat])
    }    
    #print(paste('Nobs(%) :',tab[istat],ndata))
}
con <- file(outfile,open="w")
writeLines(text[2:length(text)], con = con)
close(con)
print(length(text)-1)


if(0==1){
      load('/gpfs/scratch/bsc32/bsc32883/data/extractions_et/cams50/data/ALL_cams50_O3_EIONET_nrt_urban_HL_20160101_20171231.RData')
    stations=as.vector(unique(data.all$station))
    datatext=''
    for (i in 1:length(stations)){datatext=c(datatext,stations[i])}
    con <- file('/gpfs/scratch/pr1ehu00/pr1ehu18/data/stations/stations_URB',open="w")
    writeLines(datatext[2:length(datatext)], con = con)
    close(con)    
}
